import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Diagramas2 extends PApplet {

//declarando vari\u00e1veisfes
//Textfields by John
FloatNumberBox Comp1;
FloatNumberBox Comp2;
FloatNumberBox Temp;

//cursor
float xcursor = 70;
float ycursor = 70;    
float temperatura;
float composicao;

//declarando diagramas e fonte 
PImage aco;
PImage nicu;
PImage pbsn;
PImage displayaco;
PImage displaynicu;
PImage displaypbsn;
PImage[] icon; //icones para a splash screen
PImage exp1, exp2, exp3, exp4, exp5;

//fontes
PFont fontText;
PFont fontButton;
PFont fontTitle;

//botoes 
Button[] diagrama;
Button  explicar;
Button back;
Button temp;
Button comp;
Button etapaAvanca;
Button etapaVolta;
Button ajuda;
Button language;
Credito credito;

boolean etapaEnd; //controla o fim da explicacao  
boolean xlock;    //trava a composicao
boolean ylock;    //trava a temperatura
boolean ajudar = false;
boolean drag = false;

//inicio = 0;
//NiCu = 1;
//PbSn = 2;
//Aco = 3;

int tipo = 0;

String fase = "L\u00cdQUIDO";
int c;

//pg guarda a estrutura da fase
PGraphics pg;
//variaveis usadas na estrutura lamelar
PGraphics pgTexture;
PGraphics pgMask1;
PGraphics pgMask2;
PGraphics pgMask3;
PGraphics pgShape;
PGraphics  lamelar;
//m\u00e1scara para fazer a textura lamelar
PImage piMask;  
PImage textura;
float raio[];

//explicacao
PImage show;//imagem a ser mostrada na explicacao
boolean flow;//controla a anima\u00e7\u00e3o
int etapa=0;
boolean explain = false; //boolean que controla se as explica\u00e7\u00f5es ser\u00e3o exibidas ou n\u00e3o ]


//vari\u00e1veis usadas na Fun\u00e7\u00e3o Alavanca
float linha1=0;
float linha2=0;
float xinicio = 70;
float xfim = 678;
float W1,W2; //W1 vai ser uma auxiliar para a fase Alfa +Fe3C
boolean t;

//lamelar
PImage lamelar1;
PImage lamelar2;
PImage lamelar3;


//a primeira dimens\u00e3o de cada vetor guarda o texto a ser mostrado (que vai variar de um a muito
//e a segunda guarda a l\u00edngua. Todos os textos estar\u00e3o na fun\u00e7\u00e3o setText                                                           
int lang = 0;                    //port = 0; eng = 1; 
//pelo bem da compreens\u00e3o m\u00fatua, dividimos isso para cada se\u00e7\u00e3o escrita 

boolean hideExplainBeta = false; // vai esconder a parte das explica\u00e7\u00f5es
//MUDE AQUI PARA DESATIVAR\ATIVAR EXPLICA\u00c7\u00c3O

int countRedraw =0; //trick for redrawing during explanation 

public void setup() {
  //size
  size(925, 610); 
  frameRate(24);
  hint(ENABLE_NATIVE_FONTS);

  Locale.setDefault(Locale.US); //necess\u00e1rio pelas textlabels

  //carregando diagramas e a fonte
  //imagens com \u00e1reas demarcadas, usadas para encontrar as fases
  //fazer a regra da alavanca  
  nicu = loadImage("nicu.png");
  pbsn = loadImage("pbsn.png");
  aco = loadImage("aco.png");
  //imagens em branco a serem mostradas
  displaynicu = loadImage("nicu1.png");
  displaypbsn = loadImage("pbsn1.png");
  displayaco = loadImage("aco1.png");
  credito= new Credito();
  //fazendo icones para splash screen
  icon = new PImage[7]; 
  icon[0] = loadImage("icon1.png");
  icon[1] = loadImage("icon2.png");
  icon[2] = loadImage("icon3.png");
  icon[3] = loadImage("icon4.png");
  icon[4] = loadImage("icon5.png");
  icon[5] = loadImage("icon6.png");
  icon[6] = loadImage("icon7.png");
  //imagens para a explica\u00e7\u00e3o 
  exp1 = loadImage("exp1.png");
  exp2 = loadImage("exp2.png");
  exp3 = loadImage("exp3.png");
  exp4 = loadImage("exp4.png");
  exp5 = loadImage("exp5.png");

  //Carregando fontes
  fontButton = loadFont("ArialUnicodeMS-28.vlw"); //estranhamente, usado para legendas
  fontText =  loadFont("ArialUnicodeMS-24.vlw");
  fontTitle = loadFont("ArialUnicodeMS-72.vlw");

  smooth();
  setText();

  //criando floatboxes
  //inicializando bot\u00f5es e caixas
  Comp1 = new FloatNumberBox(displayaco.width, 212, 80, 20, 1.0f, 2, 100.0f, 0.0f, 0.01f, 1, 1, 1.0f/8.0f, color(0));
  Comp2 = new FloatNumberBox(displayaco.width, 237, 80, 20, 1.0f, 2, 100.0f, 0.0f, 0.01f, 1, 1, 1.0f/8.0f, color(0));
  Temp = new FloatNumberBox(displayaco.width, 152, 80, 20, 1.0f, 2, 3000.0f, 0.0f, 0.01f, 1, 1, 1.0f/8.0f, color(0));

  diagrama = new Button[3];

  diagrama[0]= new Button(185, 270, 122, 40,  polyControl[1][lang], true);
  diagrama[1]= new Button(470, 270,  122,40,polyControl[2][lang], true);
  diagrama[2]= new Button(740, 270, 122,40,polyControl[3][lang], true);

  explicar = new Button(aco.width+3, 87, 80,30,polyControl[4][lang], true);
  comp = new Button(displayaco.width+107, 183, 75,20,polyControl[6][lang], true);
  temp = new Button(displayaco.width+107,138,75,20,polyControl[6][lang], true);

  language = new Button(displayaco.width+120,580,80,30,"English", true);


  if(!hideExplainBeta) {
    ajuda = new Button(displayaco.width+94, 87, 80,30, polyControl[8][lang], true);
    back = new Button(displayaco.width +51, 41, 80,30, polyControl[5][lang], true);
  }
  else {
    ajuda = new Button(displayaco.width+3, 87, 80,30, polyControl[8][lang], true);
    back = new Button(displayaco.width +100, 87, 80,30, polyControl[5][lang], true);
  }

  etapaVolta = new Button(350,430, 40,20,"<<", true);
  etapaAvanca = new Button(400, 430, 40,20,">>", true);

  //PGraphics que desenha a estrutura
  pg = createGraphics(100, 100, P2D); 

  //PGraphics que armazena a textura lamelar
  lamelar = createGraphics(150,150, P2D);
  pgMask1 = createGraphics(100, 100, P2D);
  pgMask2 = createGraphics(100, 100, P2D);
  pgMask3 = createGraphics(100, 100, P2D);
  pgShape = createGraphics(100, 100, P2D);
  raio = new float[4];
}

//desenha a imagem
public void draw() {
  noLoop();
  // println(frameRate);
  background(255);

  if(tipo == 0) {
    fill(0);
    textFont(fontTitle,48);
    textAlign(CENTER,CENTER);
    fill(31,142,0);
    text(polyScreen[0][lang], g.width/2, 55);
    textFont(fontText, 20);
    textAlign(CENTER);
    textLeading(20);
    fill(0);
    text(polyScreen[1][lang]
      ,width/2, 110); 

    fill(31,142,0);
    text(polyScreen[2][lang], width/2, 225);
    fill(0);
    textFont(fontText, 18);
    textAlign(LEFT);
    imageMode(CENTER);
    image(icon[0],width/2-280, 350);
    image(icon[1],width/2+8, 350);
    image(icon[2],width/2+280, 350);
    imageMode(CORNER);
    textSize(13);
    textLeading(14);
    text(polyScreen[3][lang],width/2-346, height*3/4-40, 695, 400);

    variable("Tabela das Fases", "Nomeia as fases presentes na liga, "+
      "apresenta a fra\u00e7\u00e3o percentual em peso "+
      "dessas fases e fornece sua composi\u00e7\u00e3o "+
      "em termos da fra\u00e7\u00e3o percentual em "+
      "peso dos componentes presentes na fase.", 436, 529, 13,  380, 427, 210, 87); 
    variable("Janela das Microestruturas", "Representa\u00e7\u00e3o visual semiquantitativa da microestrutura da liga.", 592, 529, 13,  590, 483, 230, 33); 
    variable("Tabela das Microestuturas", "Nomeia as microestruturas presentes e fornece sua fra\u00e7\u00e3o percentual em peso na liga.", 338, 543, 13,  338, 545, 230, 33); 
    //(String var, String explicacao, float x, float y, int f, float boxPosx, float boxPosy, float boxWidth, float boxHeight)*/
    manageButtons();
    credito.display();
  }
  else {     
    credito.showCred= false;
    //controlando os tipos de diagramas a serem mostrados
    //escrevendo as legendas
    textAlign(CENTER,CENTER);

    if(tipo==1) {
      image(displaynicu,0,0);
      //titulo
      fill(177,17,23);
      textFont(fontText, 16);
      text("L\u00edquido", 253,190);
      text("S\u00f3lido \u0251", 495, 413);
      pushMatrix();
      translate(268, 360);
      rotate(-PI/6.5f);
      text("Linha L\u00edquidus", 0, -28);
      text("Linha Solidus", 0, 23);
      popMatrix();

      fill(31,142,0);
      textFont(fontTitle, 24);
      text(polyScreen[4][lang],aco.width/2, 35);
      fill(0);
      textFont(fontButton,14);
      if(!explain) {
        for(int i = 67; i<=539; i+=78) {   
          text(100*(600*(i-539)/(100*(70-539))+10),   50,i);
        }
        for(int i = 70; i<=690; i+=122) {
          text(20*(i-70)/122, i, 550,i);
        }
        //Fazendo a alavanca tamb\u00e9m dar a temperatura 

        textFont(fontButton,20);
        text(polyScreen[7][lang], displayaco.width/2, displayaco.height-30);
        textAlign(LEFT);
        pushMatrix();
        rotate(-PI/2);
        textFont(fontButton,20);
        text(polyControl[0][lang], -displayaco.width/2+10, 30) ;
        popMatrix();
      }

      fill(0);
      textFont(fontText, 18);
      textAlign(CENTER,CENTER);
      textLeading(16);
      text(polyControl[16][lang], 758,179);
      text("Cu", 801, 210);
      text("Ni", 799,234);
      text(polyControl[15][lang], 758, 135);
      text("\u00baC", 801, 148);
    }

    if(tipo==2) {
      //titulo
      fill(31,142,0);
      textFont(fontTitle, 24);
      text(polyScreen[5][lang], aco.width/2, 35);
      textFont(fontButton,14);
      image(displaypbsn,0,0);      

      fill(177,17,23);
      textFont(fontText, 16);
      text("L\u00edquido", 475,166);
      text("L\u00edquido+\u0251", 264, 248);
      text("L\u00edquido+\u03b2", 602, 266);
      text("\u0251", 110, 267);
      text("\u03b2", 670, 296);
      text("\u0251+\u03b2", 414, 396);

      fill(0);
      if(!explain) {
        for(int i = 136; i<=539; i+=134) {
          text((300)*(i-539)/(10*(137-539))*10, 50,i);
        }
        for(int i = 70; i<=690; i+=122) {
          text(20*(i-70)/122, i, 550,i);
        }
        //  text("\u00baC", 801, 148);
        textFont(fontButton,20);
        text(polyScreen[8][lang], displayaco.width/2, displayaco.height-30);
        textAlign(LEFT);
        pushMatrix();
        rotate(-PI/2);
        textFont(fontButton,20);
        text(polyControl[0][lang], -displayaco.width/2+10, 30) ;
        popMatrix();
      }
      textAlign(CENTER,CENTER);
      fill(0);
      textFont(fontText, 18);
      textLeading(16);
      text(polyControl[16][lang], 758,179);
      text("Pb", 801, 210);
      text("Sn", 801,234);
      text(polyControl[15][lang], 758, 135);
      text("\u00baC", 801, 148);
    }

    if (tipo==3) {
      //titulo
      fill(31,142,0);
      textFont(fontTitle, 24);
      text(polyScreen[6][lang], aco.width/2, 35);


      image(displayaco, 0,0);
      fill(177,17,23);
      textFont(fontText, 12);
      text("L\u00edquido", 486,180);
      text("Fe\u2083C+L\u00edquido", 579, 233);
      text("\u03b3+L\u00edquido", 272, 195);


      fill(0);
      textFont(fontButton,14);

      if(!explain) {
        for(int i = 70; i<=539; i+=78) {
          text(100*((1200)*(i-539)/(100*(70-539))+4), 50,i);
        }
        for(int i = 70; i<=690; i+=91) {
          text((i-70)/91, i, 550,i);
        }

        textFont(fontButton,20);
        text(polyScreen[9][lang], displayaco.width/2, displayaco.height-30);
        textAlign(LEFT);
        pushMatrix();
        rotate(-PI/2);
        textFont(fontButton,20);
        text(polyControl[0][lang], -displayaco.width/2+10, 30) ;
        popMatrix();
      }
      textAlign(CENTER,CENTER);
      fill(0);
      textFont(fontText, 18);
      textLeading(16);
      text(polyControl[16][lang], 758,179);
      text("Fe", 800, 210);
      text("C", 796,234);
      text(polyControl[15][lang], 758, 135);
      text("\u00baC", 801, 148);
    }

    fill(0);
    //desenha a estrutura
    Desenho(W2, fase);

    image(pg,  displayaco.width-35, 260, 180,120);  
    //Exce\u00e7\u00f5es n\u00e3o desenhadas mais em desenho, por ficarem por cima da imagem do desenho
    if(fase == "TRANSI\u00c7\u00c3O\nDE FASES") {
      pg.background(255);
      pg.fill(0);   
      //redraw();
      //DrawGrao(pg, 0, 0);
      fill(255);
      //stroke(0);
      strokeWeight(1.2f);
      rect(716,262,176,116);
      fill(0);
      textAlign(CENTER,CENTER);  

      textFont(fontText,16);
      textLeading(16);
      if((explain)&&( ((tipo==3)&&(etapa<=2))||(tipo==2&&etapa<2))) {
      }
      else {
        if(lang == 0) text("Transi\u00e7\u00e3o de\nFases",801,320);
        if(lang == 1) text("Phase\nTransition", 801, 320);
      }
      //}   

      textAlign(LEFT);
    }

    if(fase == "L\u00cdQUIDO") {
      pg.background(255);
      pg.fill(0);   
      //redraw();
      //DrawGrao(pg, 0, 0);
      fill(240);
      //stroke(0);
      strokeWeight(1.2f);
      rect(716,262,176,116);
      fill(0);
      textAlign(CENTER,CENTER);  

      textFont(fontText,16);
      text("L\u00edquido",801,320); 
      DrawGrao(pg, 0, 0);
      textAlign(LEFT);
    }


    //////




    //Barra do cursor, bom feedback 
    stroke(0,240); 
    line(linha1, ycursor,linha2, ycursor);
    //desenha o cursor
    fill(0);  
    ellipse(xcursor, ycursor, 5, 5);
    //desenha a tabela
    tabela(displayaco.width-35, 390);
    //faz a explica\u00e7\u00e3o
    // if(!hideExplainBeta) {
    if(explain == true) {
      Fase(); 
      explicacao();
      explicar.texto = polyControl[9][lang];
      redraw();
    }
    else explicar.texto = polyControl[10][lang];
    //}
    manageButtons();

    if(ajudar==true) {
      ajuda.texto=polyControl[11][lang];
      fill(240, 240);
      noStroke();
      rect(277-20,63-10,425, 426);
      fill(0);
      textFont(fontText, 24);
      text("Ajuda", 325-20,260+10);  
      textFont(fontText, 14);
      textLeading(12);
      textAlign(LEFT);
      stroke(0);

      text("Clique para voltar \u00e0 tela inicial", 385-20,65-10, 300, 300);  
      line(580-20,75-10,748,41);
      text("Clique para exibir uma explica\u00e7\u00e3o sobre o diagrama de fases", 385-20,85-10, 306, 300);
      line(655-20,97-10,702,92);
      text("Temperatura da liga: clique na caixa de texto e digite uma temperatura no intervalo mostrado no diagrama ou controle arrastando o cursor sobre o diagrama",  385-20,123-10, 300, 300);
      line(666,148, 706, 147);
      text("Clique para travar a temperatura da liga", 385-20,186-20, 300, 300);
      line(642-20,183-10, 806, 148);
      text("Composi\u00e7\u00e3o da liga: clique nas caixas de texto e digite uma composi\u00e7\u00e3o (em peso) para cada elemento da liga ou controle arrastando o cursor sobre o diagrama", 385-20,194-10, 300, 300);
      line(680-20,210,703,214);
      text("Clique para travar a composi\u00e7\u00e3o da liga",  385-20,247-10, 300, 300);
      line(640-20,248,806,192  );

      text("Representa\u00e7\u00e3o visual qualitativa da microestrutura da liga, baseada nas fases presentes na liga (cor) e em suas fra\u00e7\u00f5es relativas (\u00e1rea ocupada), calculadas pela Regra da Alavanca",385-20,265-10, 300, 300);
      line(639,284,707,321);

      text("Fase: nomeia as fases presentes na liga. A cor de "+
        "fundo da c\u00e9lula corresponde \u00e0 cor utilizada para "  +
        "representar a fase na janela das microestruturas\n" +
        "Fra\u00e7\u00e3o (%p): fra\u00e7\u00e3o percentual em peso das "+
        "diferentes fases presentes na liga\nComposi\u00e7\u00e3o (%p): composi\u00e7\u00e3o das fases, expressa "+
        "em termos da fra\u00e7\u00e3o percentual em peso dos "+
        "componentes presentes na fase\n"+
        "Observa\u00e7\u00e3o: Todos os valores num\u00e9ricos foram "+
        "calculados utilizando-se a Regra da Alavanca ",385-20,330-10, 300, 300);

      line(673-20,395-10, 710, 402);

      if((fase=="ALFA+BETA")||(fase=="PERLITA")||(fase=="AUSTENITA+CEMENTITA")) {
        fill(240, 240);
        noStroke();
        rect(277-20,488-10,425, 110);
        fill(0);  
        text("Microestrutura: nomeia as microestruturas presentes "+
          "na liga. O padr\u00e3o utilizado para o fundo da c\u00e9lula "+
          "corresponde ao padr\u00e3o utilizado para representar a "+
          "microestrutura na janela das microestruturas\n"+
          "Fra\u00e7\u00e3o (%p): fra\u00e7\u00e3o percentual em peso das "+
          "diferentes microestruturas presentes na liga, obtidas "+
          "com base na Regra da Alavanca",385-20,485-10, 300, 300);
        stroke(0);
        line(680-20,528-10, 710, 500);
      }
    }

    else ajuda.texto=polyControl[12][lang];
  }

  if(explain) {
    if((flow==true)) {
      loop();
      composicao();
      temperatura();
      // fun\u00e7\u00e3o fase (checa a fase da regi\u00e3o do diagrama) 
      // fun\u00e7\u00e3o alavanca (faz a regra da alavanca e d\u00e1 a composi\u00e7\u00e3o percentual)
      Alavanca();

      Temp.setData(temperatura);
      Comp1.setData(100-composicao); 
      Comp2.setData(composicao);
    }
    else {
      if(countRedraw == 0) noLoop();
      else {
        countRedraw--;
        loop();
        composicao();
        temperatura();
        // fun\u00e7\u00e3o fase (checa a fase da regi\u00e3o do diagrama) 
        Fase(); 
        // fun\u00e7\u00e3o alavanca (faz a regra da alavanca e d\u00e1 a composi\u00e7\u00e3o percentual)
        Alavanca();
        Temp.setData(temperatura);
        Comp1.setData(100-composicao); 
        Comp2.setData(composicao);
      }
    }
  }
}

boolean moving=false;

public void mouseMoved() {
  if(tipo==0)    redraw();
  else {
    if((mouseY>19)&&(mouseY<250)&&(mouseX>690)&&(mouseX<914)) {
      redraw();
    }
    if(explain) redraw();
  }
}

public void manageCursor() {
  redraw();
  if((mouseX>=60)&&(mouseX<690)&&(mouseY>=60)&&(mouseY<550)) {
    if(!explain) {
      if(!ylock) xcursor = mouseX;
      if(!xlock) ycursor = mouseY;
    }
  }
  if(xcursor<70) xcursor = 70;
  if(xcursor>678) xcursor = 678;
  if(ycursor<70) ycursor = 70;
  if(ycursor>539) ycursor = 539;
}  

//controla o cursor sobre os diagramas
public void mouseDragged() {
  manageCursor();
  composicao();
  temperatura();
  // fun\u00e7\u00e3o fase (checa a fase da regi\u00e3o do diagrama) 
  Fase(); 
  // fun\u00e7\u00e3o alavanca (faz a regra da alavanca e d\u00e1 a composi\u00e7\u00e3o percentual)
  Alavanca();
  Temp.setData(temperatura);
  Comp1.setData(100-composicao); 
  Comp2.setData(composicao);

  redraw();
}

public void mousePressed() {  
  println(mouseX + " " + mouseY);
  //analisamos se os bot\u00f5es foram acionados
  moving = true;

  if(tipo ==0) {
    credito.mousePressed();
    //clicando no icone, clica no bot\u00e3o

    if((mouseY>293)&&(mouseY<403)) {
      if((mouseX>120)&&(mouseX<240)) diagrama[0].pressed=true;
      if((mouseX>408)&&(mouseX<530)) diagrama[1].pressed=true;
      if((mouseX>680)&&(mouseX<800)) diagrama[2].pressed=true;
    }

    if (diagrama[0].press() == true) {
      tipo = 1;
      Temp.MaxData=1600;
      Temp.MinData =1000;
      Comp1.MinData = 0;
      Comp2.MaxData = 100;

      xcursor = 70;
      ycursor = 70;
      // fun\u00e7\u00e3o alavanca (faz a regra da alavanca e d\u00e1 a composi\u00e7\u00e3o percentual)
      Alavanca();
      composicao();
      temperatura();
      // fun\u00e7\u00e3o fase (checa a fase da regi\u00e3o do diagrama) 
      Fase(); 
      Temp.setData(temperatura);
      Comp1.setData(100-composicao); 
      Comp2.setData(composicao);
      pushStyle();
      Desenho(W2, fase);
      popStyle();
      loop();
    }

    if (diagrama[1].press() == true) {
      tipo = 2;
      Temp.MaxData=350;
      Temp.MinData =0;
      Comp1.MinData = 0;
      Comp2.MaxData = 100;

      xcursor = 70;
      ycursor = 70;
      // fun\u00e7\u00e3o alavanca (faz a regra da alavanca e d\u00e1 a composi\u00e7\u00e3o percentual)
      Alavanca();
      composicao();
      temperatura();
      // fun\u00e7\u00e3o fase (checa a fase da regi\u00e3o do diagrama) 
      Fase(); 
      Temp.setData(temperatura);
      Comp1.setData(100-composicao); 
      Comp2.setData(composicao);
      pushStyle();
      Desenho(W2, fase);
      popStyle();
      loop();
    }

    if (diagrama[2].press() == true) { 
      tipo = 3;
      Temp.MaxData=1600;
      Temp.MinData =400;
      Comp2.MaxData = 6.7f;

      xcursor = 70;
      ycursor = 70;
      // fun\u00e7\u00e3o alavanca (faz a regra da alavanca e d\u00e1 a composi\u00e7\u00e3o percentual)
      Alavanca();
      composicao();
      temperatura();
      // fun\u00e7\u00e3o fase (checa a fase da regi\u00e3o do diagrama) 
      Fase(); 
      Temp.setData(temperatura);
      Comp1.setData(100-composicao); 
      Comp2.setData(composicao);
      loop();
    }
  }

  if((ajuda.press()==true)&&(ajudar==true)) {
    ajudar = false;
  }
  else if((ajuda.press() == true)&&(ajudar==false)) {
    ajudar = true;
    explain=false;
  } 

  if((explicar.press()==true)&&(explain==true)) {
    explain = false;
    etapa=0;
  }
  else if((explicar.press() == true)&&(explain==false)) {
    explain = true;
    countRedraw = 3;
    ajudar = false;
  } 

  if (back.press() == true) {
    tipo = 0;
    explain=false;
    ajudar=false;
    etapa=0;
    comp.texto=polyControl[6][lang];
    temp.texto=polyControl[6][lang];   
    xlock=false;
    ylock=false;
  }
  if(!explain) {
    if((temp.press()==true)&&(xlock==true)) {
      xlock =  false;
      temp.texto=polyControl[6][lang];
    }
    else if((temp.press() == true)) {
      xlock = true;   
      temp.texto=polyControl[7][lang];
      ylock = false;
      comp.texto=polyControl[6][lang];
    } 

    if((comp.press() == true)&&(ylock==true)) {
      ylock = false;
      comp.texto=polyControl[6][lang];
    }
    else if((comp.press() == true)) {
      ylock = true;   
      comp.texto=polyControl[7][lang];   

      xlock =  false;
      temp.texto=polyControl[6][lang];
    }
  }
  if((etapaAvanca.press()==true)&&(etapaEnd==false)) {
    etapa++;
    flow=true;
    countRedraw = 3;
  }
  if((etapaVolta.press()==true)&&(etapa>0)) {
    etapa--;
    flow=false;
    countRedraw = 3;
  }
}

public void mouseReleased() {
  redraw();
  credito.mouseReleased();  
  diagrama[0].release();
  diagrama[1].release();
  diagrama[2].release();
  explicar.release();
  back.release();
  comp.release();
  temp.release();
  etapaAvanca.release();
  etapaVolta.release();
  ajuda.release();
  language.release();
}

public void manageButtons() {
  if(tipo == 0) {
    diagrama[0].display();
    diagrama[1].display();
    diagrama[2].display();
    language.update();
    //language.display();
    diagrama[0].update();
    diagrama[1].update();
    diagrama[2].update();
    //clicando no icone, clica no bot\u00e3o
    if((mouseY>293)&&(mouseY<403)) {
      if((mouseX>120)&&(mouseX<240)) diagrama[0].over=true;
      if((mouseX>408)&&(mouseX<530)) diagrama[1].over=true;
      if((mouseX>680)&&(mouseX<800)) diagrama[2].over=true;
    }

    if(credito.showCred) {
      diagrama[0].over=false;
      diagrama[1].over=false;
      diagrama[2].over=false;
    }
  } 

  else {
    back.display();
    comp.display();
    temp.display();
    ajuda.display();
    if(!hideExplainBeta) explicar.display();
    imageMode(CENTER);


    Comp1.display();
    Comp2.display();
    Temp.display();

    if((explain&&((tipo==2&&etapa<2)||(tipo==3&&etapa<3)))) {
      fill(209);
      rect(719,146,60,13);
      rect(719,205,60,13);
      rect(719,230,60,13);
    }
    imageMode(CORNER);

    explicar.update();
    ajuda.update();
    comp.update();
    temp.update();
    if(explain) {
      if(!etapaEnd) etapaAvanca.display();
      etapaAvanca.update(); 

      if(etapa>0)  etapaVolta.display();
      etapaVolta.update();
    }
  }
  back.update(); //WATCH!
}

public void mouseClicked() { 
  redraw();
  Temp.mouseClicked();
  Comp1.mouseClicked();
  Comp2.mouseClicked();
}

public boolean AUX_PulseSwitch(int time) { 
  /*   Changes return value (true or false) every TIME milliseconds.
   Keeps returning TRUE for TIME milliseconds, then FALSE for the next TIME milliseconds,
   then TRUE again for the next TIME milliseconds, and so on. Based on millis(), thus
   counting of time is global, dependent on when process-runtime
   */
  boolean returnvalue;
  redraw();
  returnvalue = (millis() % (time*2) <= time) ? (true) : (false);
  return returnvalue;
}

public void keyPressed() {
  redraw();
  if (key == ENTER) {
    if (tipo==1) { 
      if(Comp1.OnFocus==true) {
        xcursor = -((Comp1.getData())/100*(678-70))+678;
        composicao();
        Comp2.setData(composicao);
      }
      else {
        xcursor = ((Comp2.getData())/100*(678-70))+70;
        composicao();
        Comp1.setData(100-composicao);
      }
      if(Temp.getData()>1000)  ycursor = ((Temp.getData()-1000)*(70-539)/600+539);
      else {
        Temp.setData(1000);
        ycursor = ((Temp.getData()-1000)*(70-539)/600+539);
      }
    }

    if (tipo==2) {
      if(Comp1.OnFocus==true) {
        xcursor = -((Comp1.getData())/100*(678-70))+678;
        composicao();
        Comp2.setData(composicao);
      }
      else {
        xcursor = ((Comp2.getData())/100*(678-70))+70;
        composicao();
        Comp1.setData(100-composicao);
      }
      ycursor = (Temp.getData()*(70-539)/350+539);
    }

    if (tipo==3) {
      if(Comp1.OnFocus==true) {
        xcursor=(((100-Comp1.getData()))/6.7f*(678-70))+70;
        composicao();         
        Comp2.setData(composicao);
      }
      else {
        xcursor=((Comp2.getData())/6.7f*(678-70))+70;
        composicao();
        Comp1.setData(100-composicao);
      }

      if(Temp.getData()>400)  ycursor = ((Temp.getData()-400)*(70-539)/1200+539);


      else {
        Temp.setData(400);
        ycursor = ((Temp.getData()-400)*(70-539)/1200+539);
      }
    }

    // fun\u00e7\u00e3o fase (checa a fase da regi\u00e3o do diagrama) 
    Fase(); 
    // fun\u00e7\u00e3o alavanca (faz a regra da alavanca e d\u00e1 a composi\u00e7\u00e3o percentual)
    Alavanca();
    // Desenho(W2, fase);


    mouseDragged();
    countRedraw = 3;
  }

  Comp1.keyPressed();
  Comp2.keyPressed();
  Temp.keyPressed();
}

//variavel usada para desenhar o diagrama do fe3cz  
public void Alavanca(){
  c=-1;
  // nomesprec guarda o nome das duas fases( caso bif\u00e1sico 
  // 0 \u00e9 fase alfa + L, 1 \u00e9 L, 2 \u00e9 alfa
  //tomando um ponto(x,y), checa os pontos de x a composicao 0
  // e de x a composicao 100 em busca da linha vermelha ou preta
  //precisa tratar os diagramas antes
  if(tipo == 1){ 
    c = nicu.pixels[PApplet.parseInt(ycursor)*nicu.width+PApplet.parseInt(xcursor)];
    t =false;
    linha1 = 70;
     linha2 = 678;
    for(float x = xcursor; x>xinicio; x-=1){
      c = nicu.pixels[PApplet.parseInt(ycursor)*nicu.width+PApplet.parseInt(x)];
      if((c==-5172969)||(c==-14475488)){
        if(t==false){
          linha1 = x;
        }
        t=true;
      }
    }
    t =false;

    for(float x = xcursor; x<xfim; x+=1){
      c = nicu.pixels[PApplet.parseInt(ycursor)*nicu.width+PApplet.parseInt(x)];
      if((c==-5172969)||(c==-14475488)){
        if(t==false){
          linha2 = x;
        }
        t=true;
      }
    }
    t =false;
  }

  if(tipo == 2){
    c = pbsn.pixels[PApplet.parseInt(ycursor)*pbsn.width+PApplet.parseInt(xcursor)];
    t =false ;
    linha1 = 70;
    linha2 = 678;
    for(float x = xcursor; x>xinicio; x-=1){
      c = pbsn.pixels[PApplet.parseInt(ycursor)*pbsn.width+PApplet.parseInt(x)];
      if((c==-5172969)||(c==-14475488)){
        if(t==false){
          linha1 = x;
        }
        t=true;
      }
    }
    t =false;
    for(float x = xcursor; x<xfim; x+=1){
      c = pbsn.pixels[PApplet.parseInt(ycursor)*pbsn.width+PApplet.parseInt(x)];
      if((c==-5172969)||(c==-14475488)){
        if(t==false){
          linha2 = x;
        }
        t=true;        
      }
    }
    t =false;
  }

  if(tipo == 3){ 
    c = aco.pixels[PApplet.parseInt(ycursor)*aco.width+PApplet.parseInt(xcursor)];
    t =false;
     linha1 = 70;
    linha2 = 678;

    for(float x = xcursor; x>xinicio; x-=1){
      c = aco.pixels[PApplet.parseInt(ycursor)*aco.width+PApplet.parseInt(x)];
      if((c==-5172969)||(c==-14475488)){
        if(t==false){
          linha1 = x;
        }
        t=true;
      }
    }
    t =false;

    for(float x = xcursor; x<xfim; x+=1){
      c = aco.pixels[PApplet.parseInt(ycursor)*aco.width+PApplet.parseInt(x)];
      if((c==-5172969)||(c==-14475488)){
        if(t==false){
          linha2 = x;
        }
        t=true;      
      }
    }
    t =false;
  }
    
  
  //aplicando a regra da alavanca
  //Sendo 1 o componente cuja linha fica a esquerda e 2 
  //o componente cuja linha fica a direita, e X,Y as 
  //coordenadas do ponto temos:
  //W2= (X-linha1)/(linha2-linha1)
  //(n\u00e3o precisando converter o comprimento em pixels
  //para composi\u00e7\u00e3o, por ser uma fra\u00e7\u00e3o)
  
  if(fase=="PERLITA"){
    if(xcursor<140){
      //achando a porcentagem de Fe3C na fase perlitica
      W2 = 1-(xcursor-73)/(140-73);
      W1 = (-(xcursor-linha1)/(linha2-linha1) +1- W2);
          println(W2);
    }
    
    
    else{
          W2 = (687-xcursor)/(687-139);
          W1 = (-(linha2-xcursor)/(linha2-linha1) + W2);
        println(W2);
    }

  } 
    
  else if(fase=="ALFA+BETA"){
    if(xcursor>181&&xcursor<=446.2f){
      //achando a porcentagem de alfa na eutetica
      W2 = (linha2-xcursor)/(linha2-181);
    }
    else if(xcursor>446.2f&&xcursor<=661){
      //achando a porcentagem de alfa na eutetica
      W2 = 1-(xcursor-linha1)/(661-linha1);//porcentagem de beta 
    }
    else{
      W2 = (xcursor-linha1)/(linha2-linha1);  
    }
  }
  
  else  W2= (xcursor-linha1)/(linha2-linha1);  
}

public void composicao(){
  if((tipo == 1)||(tipo == 2)){
    composicao = ((xcursor-xinicio)*100/(xfim-xinicio));
  }
  else{
    composicao = (xcursor-xinicio)*6.7f/(xfim-xinicio);
  }
}

public void temperatura(){
  if(tipo == 1){
    temperatura =600*(ycursor-539)/(70-539)+1000;
  }
  if(tipo == 2){
    temperatura = (300)*(ycursor-539)/(137-539);
  }
  if(tipo == 3){
    temperatura = (1200)*(ycursor-539)/(70-539)+400;
  }
}


class Button {
  int x, y; // The x- and y-coordinates
  int width, height; // Dimension (width and height)
  boolean over = false; // True when the mouse is over
  boolean pressed = false; // True when the mouse is over and pressed
  String texto;
  float c = 1.65f, b = 3.5f;
  int fontsize;
  int lines, cols; // aux counter vars for fontsize determination (from text string)
  boolean show;
  int Color=color(0); //color of the letters

  Button(int xp, int yp, int width, int height,String texto, boolean show) {
    x = xp;
    y = yp;
    this.width =  width;
    this.height = height;
    this.texto = texto; 
    this.show = show;
    fontsize = 16;
  }

  // Updates the over field every frame
  public void update() {
    if ((mouseX >= x-width/2) && (mouseX <= x+width/2) &&
      (mouseY >= y-height/2) && (mouseY <= y+height/2)) {
      over = true;
    } 
    else {
      over = false;
    }
  }
  //problemas a vista
  public boolean press() {
    if (over == true) {
      pressed = true;
      return true;
    } 
    else {
      return false;
    }
  }

  public void release() {
    pressed = false; // Set to false when the mouse is released
    fill(0);
  }

  public void display() {
    if(show == true) { 
      int shade,light,plateau,selected,TMPcolor;

      plateau = TMPcolor = color(0xffAAAAAA);
      shade = lerpColor(0xff000000, plateau, 0.8f);
      light = lerpColor(0xffFFFFFF, plateau, 0.8f);
      selected = color(255-red(plateau), 255-green(plateau), 255-blue(plateau));
      beginShape(QUADS);
      noStroke();

      if (pressed == true) {
        fill(lerpColor(selected, light, 0.9f));
      } 
      else if (over == true) {
        fill(light);
      } 
      else {
        fill(shade);
      }
      vertex(x - (width + b)/2, y - (height + b)/2);
      vertex(x - (width)/2, y - (height)/2);
      vertex(x - (width)/2, y + (height)/2);
      vertex(x - (width + b)/2, y + (height + b)/2);

      vertex(x - (width + b)/2, y + (height + b)/2);
      vertex(x - (width)/2, y + (height)/2);
      vertex(x + (width)/2, y + (height)/2);
      vertex(x + (width + b)/2, y + (height + b)/2);

      if (pressed == true) {
        fill(lerpColor(selected, shade, 0.9f));
      } 
      else if (over == true) {
        fill(shade);
      } 
      else {
        fill(light);
      }
      vertex(x - (width + b)/2, y - (height + b)/2);
      vertex(x - (width)/2, y - (height)/2);
      vertex(x + (width)/2, y - (height)/2);
      vertex(x + (width + b)/2, y - (height + b)/2);

      vertex(x + (width + b)/2, y - (height + b)/2);
      vertex(x + (width)/2, y - (height)/2);
      vertex(x + (width)/2, y + (height)/2);
      vertex(x + (width + b)/2, y + (height + b)/2);
      endShape();

      if (pressed == true) {
        fill(lerpColor(selected, shade, 0.5f));
      } 
      else if (over == true) {
        fill( lerpColor(shade, plateau, 0.7f));
      } 
      else {
        fill(plateau);
      }
      rectMode(CENTER);
      rect(x, y, width, height);


      if (pressed == true) {
        fill(lerpColor( color((brightness(TMPcolor) > 128) ? (0) : (255)), TMPcolor, 0.7f));
      } 
      else if (over == true) {
        fill(lerpColor( color((brightness(TMPcolor) > 128) ? (0) : (255)), light, 0.2f));
      } 
      else {
        fill(lerpColor( color((brightness(TMPcolor) > 128) ? (0) : (255)), shade, 0.2f));
      }
    }



    textAlign(CENTER, CENTER);
    textFont(fontButton, fontsize);
    textLeading(fontsize);
    fill(Color);
    text(texto, x+c/2, y-1.2f*b);
    //textAlign(LEFT);  
    rectMode(CORNER);
    textFont(fontText,20);
  }
}

class Credito{
  Button botao;
  Button processing;
  boolean showCred;
  boolean mais;

  Credito(){
    //int xp, int yp, int width, int height,String texto, boolean show
    botao = new Button(displayaco.width+120, 30, 80,30,  polyScreen[10][lang], true);
    processing  =new Button(310 ,240, 90, 15, "Processing", false);
    processing.Color= color(4, 51, 255);
    processing.fontsize = 14;
    
    mais = false;
    showCred = false;
  }

  public void display(){     
        
    rectMode(CORNERS);   
    if( showCred == true){
      //fill(15, 50);
      //rect(0, 0, width, height);
           botao.texto =  polyControl[13][lang];   
      textAlign(LEFT);
      textFont(fontText ,14);    
      fill(240, 240);  
      textLeading(14);
      if(mais){
        //rect(width-30, height/2, 400, 400);
        rect(width/2 - 290, height/2 - 270, width/2 + 300, height/2 + 245);
        fill(0);
        text(polyScreen[11][lang]
          ,width/2 - 260, height/2 - 245);
      }

      else if(!mais){
        rect(width/2 - 290, height/2 - 270, width/2 + 300, height/2 + 260);
        fill(0);
        text(polyScreen[12][lang]
         ,width/2 - 260, height/2 - 245);
      }     
      
      processing.display();
      processing.update();
   }else     botao.texto =  polyControl[14][lang];
    textFont(fontButton, 16);
    botao.display();
    botao.update();
    
  if(processing.over) processing.Color = color(100,100,255);
  else if((mais)) processing.Color  = color(100);
  else processing.Color = color(50, 50, 255);
}
  
public void mousePressed(){
if((processing.press()==true)&&(mais==true)){
    mais = false;
  }
  else if((processing.press() == true)&&(mais==false)){
    mais = true;   
  } 
   botao.update();
   
  if((botao.press()==true)&&(showCred==true)){
    showCred = false;
  }
  else if((botao.press() == true)&&(showCred==false)){
    showCred = true;
  } 
 }
 
 public void mouseReleased(){
   botao.release();
 }
 
}
float Agrao;
//Desenha, num PGraphics, a microestrutura da liga
//definindo cores das fases 

public void Desenho(float W2, String fase) { 
  pg.beginDraw();
  pg.background(255);

  if(fase == "L\u00cdQUIDO+ALFA") {
    pg.background(240);
    pg.fill(ALFA);
    if(tipo==1) {
      cresceGrao(W2, pg,false);
      DrawGrao(pg, 0, 0);//por algum motivo, isso acaba com os problemas gerados pelo JAVA2D
    }
    if(tipo==2) {
      cresceGrao(1-W2,pg,false);
      DrawGrao(pg, 0, 0);//por algum motivo, isso acaba com os problemas gerados pelo JAVA2D
    }
  }
  if(fase == "L\u00cdQUIDO+BETA") {
    pg.background(240);
    pg.fill(BETA);
    cresceGrao(W2,pg, false);
    DrawGrao(pg, 0, 0);//por algum motivo, isso acaba com os problemas gerados pelo JAVA2D
  }
  if((fase == "L\u00cdQUIDO+GAMA")||(fase=="L\u00cdQUIDO+AUSTENITA")) {
    pg.background(240);
    pg.fill(GAMA);
    cresceGrao( 1-W2,pg,false);
    DrawGrao(pg, 0, 0);//por algum motivo, isso acaba com os problemas gerados pelo JAVA2D
  }
  if((fase =="L\u00cdQUIDO+FERRITA (DELTA)")) {
    pg.background(240);
    pg.fill(DELTA);
    cresceGrao(1-W2,pg,false);
    DrawGrao(pg, 0, 0);//por algum motivo, isso acaba com os problemas gerados pelo JAVA2D
  }
  if(fase == "L\u00cdQUIDO+CEMENTITA") {
    if(xcursor==678) {      
      pg.fill(FE3C);
      DrawGrao(pg, 0, 1);
      DrawGrao(pg, 1, 1 );
      DrawGrao(pg, 2, 1);
      DrawGrao(pg, 3, 1);
    }
    else {
      pg.background(240);
      pg.fill(FE3C);
      cresceGrao(W2,pg,false);
      DrawGrao(pg, 0, 0);//por algum motivo, isso acaba com os problemas gerados pelo JAVA2D
    } 
  }  

  //Desenha as fases L\u00cdQUIDO +,  crescendo gr\u00e3os simples com cresceGrao
  // desenha as fases monof\u00e1sicas
  if((fase == "ALFA")||(fase == "BETA")||(fase=="FERRITA (ALFA)")||(fase=="FERRITA (DELTA)")||(fase=="FERRITA (ALFA)")||(fase=="AUSTENITA")) {
    if(fase == "BETA") pg.fill(BETA);
    if((fase=="AUSTENITA")) pg.fill(GAMA);
    if((fase=="FERRITA (DELTA)")) pg.fill(DELTA);
    if((fase == "ALFA")||(fase=="FERRITA (ALFA)")) pg.fill(ALFA);

    DrawGrao(pg, 0, 1);
    DrawGrao(pg, 1, 1 );
    DrawGrao(pg, 2, 1);
    DrawGrao(pg, 3, 1);
  }

  // fazendo as fases com estrutura lamelar
  if(fase == "ALFA+BETA") {  
    //desenhas as precipitacoes, usando randomSeed para controle
    if (((xcursor -70)/(678-70)) < 0.183f) {
      pg.fill(ALFA);
      DrawGrao(pg, 0, 1);
      DrawGrao(pg, 1, 1 );
      DrawGrao(pg, 2, 1 );
      DrawGrao(pg, 3, 1);     
      pg.stroke(BETA);
      precipita(W2);  
      pg.stroke(0);
    }
    if (((xcursor -70)/(678-70)) > 0.958f) {
      pg.fill(BETA);
      DrawGrao(pg, 0, 1);
      DrawGrao(pg, 1, 1 );
      DrawGrao(pg, 2, 1 );
      DrawGrao(pg, 3, 1);   
      pg.stroke(ALFA);
      precipita(1-W2);  
      pg.stroke(0);
    }   

    if((((xcursor -70)/(678-70)) > 0.183f)&&((xcursor -70)/(678-70))<0.62f) {
      Textura(1-W2, fase, false);   //attention
      DrawTextured(1, fase, false, false); 
      pg.fill(ALFA);
      cresceGrao(1- ((xcursor - 178)/(445 - 178)),pg, false);
    }
    if((((xcursor -70)/(678-70)) > 0.62f)&&((xcursor - 79)/(678-70))<0.958f) {
      Textura(W2, fase, false);  
      DrawTextured(1,fase, false, false); 
      pg.fill(BETA);
      cresceGrao((xcursor - 432)/(635-432),pg,false);
    }
  }

  if(fase=="FERRITA (ALFA)+AUSTENITA") { 
    //desenha as estruturas n\u00e3o eut\u00e9ticas 

    pg.background(ALFA);
    pg.fill(GAMA);
    DrawGrao(pg, 0, sqrt(W2));
    DrawGrao(pg, 1, sqrt(W2));
    DrawGrao(pg, 2, sqrt(W2));
    DrawGrao(pg, 3, sqrt(W2));       
    pg.endDraw();
  }

  if(fase=="AUSTENITA+CEMENTITA") { 
    //desenha as estruturas n\u00e3o eut\u00e9ticas 
    if(xcursor<=622) {
      pg.background(FE3C);
      pg.fill(GAMA);
      DrawGrao(pg, 0, sqrt(1-W2));
      DrawGrao(pg, 1, sqrt(1-W2));
      DrawGrao(pg, 2, sqrt(1-W2));
      DrawGrao(pg, 3, sqrt(1-W2));       
      pg.endDraw();
    }

    if((xcursor  > 262)&&(xcursor<=461)) {
      Textura(W2, fase, true);   
      DrawTextured(1, fase, true, true); 

      pg.fill(GAMA);
      cresceGrao( 1-((xcursor - 262)/(461 - 262)), pg, false);
    }

    if((xcursor > 461)&&(xcursor<678)) {
      Textura(W2, fase, true);  
      DrawTextured(1,fase,true,true);  
      pg.fill(FE3C);
      cresceGrao((xcursor - 461)/(678-461),pg,false);
    }
    if(xcursor==678) {      
      pg.fill(FE3C);
      DrawGrao(pg, 0, 1);
      DrawGrao(pg, 1, 1 );
      DrawGrao(pg, 2, 1);
      DrawGrao(pg, 3, 1);
    }
  }
  if(fase=="FERRITA (DELTA)+AUSTENITA") { 
    //desenha as estruturas n\u00e3o eut\u00e9ticas 
    pg.background(GAMA);
    pg.fill(DELTA);
    DrawGrao(pg, 0, sqrt(1-W2));
    DrawGrao(pg, 1, sqrt(1-W2));
    DrawGrao(pg, 2, sqrt(1-W2));
    DrawGrao(pg, 3, sqrt(1-W2));       
    pg.endDraw();
  }
  if(fase=="PERLITA") { 
    //desenha as estruturas n\u00e3o eut\u00e9ticas 
    // Textura(W2, fase);  
    if(xcursor<=262) {
      if(xcursor<140) {         
        Textura(1-W1, fase,false);  
        pg.background(ALFA);
        DrawTextured((sqrt(1-W2)), fase, false,false);
      }
      else {
        Textura(W1, fase,false);  
        pg.background(FE3C);
        DrawTextured((sqrt(W2)), fase, false,false);
      }
    }
    else {
      if((xcursor  > 262)&&(xcursor<=461)) {
        Textura(1-W2, fase, true);   
        DrawTextured(1, fase, false, true ); 

        lamelar(W2, 0, fase, false);
        //image(lamelar1, 0,0);
        Textura(1-W2, fase, false);
        pgShape.background(255);
        pgMask1.background(0);
        cresceGrao( 1- ((xcursor - 262)/(461 - 262)),pg,true);
        cresceGrao( 1- ((xcursor - 262)/(461 - 262)),pgMask1,true);
        piMask = pgMask1.get(0, 0, width, height);
        pgShape.background(0);
        pgShape.image(lamelar1, 0, 0);
        pgShape.mask(piMask);
        pg.image(pgShape, 0,0);
        // Textura(W2, fase, false);
      }


      if((xcursor > 461)&&(xcursor<678)) {
        Textura(1-W2, fase, true);  
        DrawTextured(1,fase,true,true); 

        pg.fill(FE3C);
        cresceGrao((xcursor - 461)/(678-461),pg,false);
      }
      if(xcursor==678) {      
        pg.fill(FE3C);
        DrawGrao(pg, 0, 1);
        DrawGrao(pg, 1, 1 );
        DrawGrao(pg, 2, 1);
        DrawGrao(pg, 3, 1);
      }
    }
  }

  //fazendo a borda do pg
  pg.stroke(0);
  pg.line(0,0,pg.width,0);
  pg.line(0,0,0,pg.height);
  pg.line(pg.height-1,0,pg.width-1,pg.height-1);
  pg.line(0,pg.width-1,pg.width-1,pg.height-1);
}

//desenha precipitacoes de beta (ou alfa) em alfa (ou beta)
//como "retas" rotacionadas 

public void precipita(float W2) {
  randomSeed(3); 
  float agrao = 0; //prcentagem de precipitado
  for(int i = 0; (agrao/10000)<W2; i++) {
    pg.pushMatrix();
    pg.translate(random(100), random(100));
    pg.rotate(random(PI));  
    pg.strokeWeight(random(1,2));
    pg.line(0, 4, 0,0) ;
    pg.popMatrix();
    agrao+=4*1.5f;
  }
  pg.strokeWeight(1);
}










//detecta fases, usando a tom de branco do fundo dos gr\u00e1ficos
//Embutindo tamb\u00e9m um detector de pontos importantes

public void Fase(){
  if (tipo ==1){
    c = nicu.pixels[PApplet.parseInt(ycursor)*nicu.width+PApplet.parseInt(xcursor)];
    fase = "TRANSI\u00c7\u00c3O\nDE FASES";
    if(c == -1) fase = "L\u00cdQUIDO";
    if(c== -327681) fase = "L\u00cdQUIDO+ALFA";
    if(c == -1281) fase = "ALFA";
  }
  if(tipo == 2){
    c = pbsn.pixels[PApplet.parseInt(ycursor)*pbsn.width+PApplet.parseInt(xcursor)];
    fase = "TRANSI\u00c7\u00c3O\nDE FASES";
    if(c == -1) fase = "L\u00cdQUIDO";
    if(c == -328961) fase ="L\u00cdQUIDO+ALFA";
    if(c ==  -1286) fase ="L\u00cdQUIDO+BETA";
    if(c==-328966) fase="ALFA+BETA";
    if(c==-6) fase = "BETA";
    if(c==-327681) fase ="ALFA";
    if(composicao==0.619f) text("PONTO EUT\u00c9TICO", 50,100);
  }

  if(tipo == 3){
    c = aco.pixels[PApplet.parseInt(ycursor)*aco.width+PApplet.parseInt(xcursor)];
    fase = "TRANSI\u00c7\u00c3O\nDE FASES";
    if(c == -1) fase = "L\u00cdQUIDO";
    if(c==-328966) fase="PERLITA";
    if(c ==  -1286) fase ="FERRITA (ALFA)";
    if(c==-6) fase = "FERRITA (ALFA)+AUSTENITA";
    if(c==-327686) fase="AUSTENITA";
    if(c==-327681) fase ="AUSTENITA+CEMENTITA";
    if(c==-131590) fase ="L\u00cdQUIDO+AUSTENITA";
    if(c==-328454) fase ="FERRITA (DELTA)";
    if(c==-197894) fase ="L\u00cdQUIDO+FERRITA (DELTA)";
    if(c==-65794) fase ="FERRITA (DELTA)+AUSTENITA";
    if(c==-131331) fase ="L\u00cdQUIDO+CEMENTITA";
  }
}

//Cores das fases
int ALFA = color(0,152,113);
int BETA = color(255,140,136);
int GAMA = color(235,238,150);
int DELTA = color(160,200,220);
int FE3C = color(174,185,172);

//desenha a textura da estrutura lamelar, usando linhas e random
public PImage lamelar(float fracao, float angulo, String fase, boolean led){
  randomSeed(6);
  int c1 = 0, c2 = 0;
  
  if(fase == "ALFA+BETA"){ 
    c1 = color(ALFA);
    c2 = color(BETA);
  }
  if(fase == "PERLITA"){ 
    c1 = color(ALFA);
    c2 = color(FE3C);
  }
  if(fase == "FERRITA (ALFA)+AUSTENITA"){ 
    c2 = color(GAMA);
    c1 = color(ALFA);
  }
  if(fase == "AUSTENITA+CEMENTITA"){ 
    c2 = color(GAMA);
    c1 = color(FE3C);
  }

  lamelar.pushMatrix();
  lamelar.beginDraw();
  lamelar.strokeWeight(2);   

  lamelar.rotate(angulo);

  if(!led){
    for(int i=0; i< lamelar.width; i+=2){
      if(random(0,1)<fracao){
        lamelar.stroke(c2);
      }
      else{
        lamelar.stroke(c1);
      }

      lamelar.line(0, i, lamelar.width/2, i) ;
      lamelar.line(0, lamelar.width/3, lamelar.width*2/3+3, i) ;
      lamelar.line(0, lamelar.width*2/3+4, lamelar.width, i) ;
    }
  }
  else{ //fazendo a estrutura da ledeburita
    lamelar.strokeWeight(2.6f);
    for(int i=0; i< lamelar.width; i+=4){
      for(int j=0; j< lamelar.height; j+=4){
         if(random(0,1)<fracao){
          if(fase=="AUSTENITA+CEMENTITA")lamelar.stroke(c2);
          else lamelar.stroke(c1);
        }  
        else{
         if(fase=="AUSTENITA+CEMENTITA") lamelar.stroke(c1);
         else lamelar.stroke(c2);
        }
        lamelar.line(i,j,i+6,j+6);
      }
    }
  }
  lamelar.stroke(0);
  lamelar.endDraw();
  lamelar.popMatrix();
  return lamelar.get();
}

//cria e rotaciona texturas
public void Textura(float fracao, String fase, boolean led){
  lamelar1 = lamelar(fracao, 0, fase, led);
  lamelar2 = lamelar(fracao, PI/10, fase, led);
  lamelar3 = lamelar(fracao, -PI/8, fase, led);
}

//desenha os gr\u00e3os com texturas aplicadas
/////////http://processing.org/discourse/yabb2/YaBB.pl?num=1229687224 - textura
public void DrawTextured(float tamanho, String fase, boolean led, boolean tipograo){ //false normal, true graos precipitando
  pg.fill(0);
  lamelar(W2, 0, fase, led);
  pgShape.background(255);
  pgMask1.background(0);
  DrawGrao(pg, 0, tamanho+0.001f);
  DrawGrao(pgMask1, 0, tamanho);
  piMask = pgMask1.get(0, 0, width, height);
  pgShape.background(0);
  pgShape.image(lamelar1, 0, 0);
  pgShape.mask(piMask);

  pgMask2.background(0);
  DrawGrao(pg, 1, tamanho+0.001f);
  DrawGrao(pgMask2, 1,tamanho);
  piMask = pgMask2.get(0, 0, width, height);
  pgShape.image(lamelar2, 0, 0);
  pgShape.mask(piMask);

  pg.image(pgShape, 0, 0);

  pgMask3.background(0);
  DrawGrao(pg, 2, tamanho+0.001f); 
  DrawGrao(pgMask3, 2,tamanho);
  piMask = pgMask3.get(0, 0, width, height);
  pgShape.image(lamelar3, 0, 0);
  pgShape.mask(piMask);

  pg.image(pgShape, 0, 0);

  DrawGrao(pg, 3, tamanho+0.001f); 
  DrawGrao(pgMask1, 3, tamanho);
  piMask = pgMask1.get(0, 0, width, height);
  pgShape.image(lamelar2, 0, 0);
  pgShape.mask(piMask);

  pg.image(pgShape, 0, 0);
}









public void explicacao() { 
  //a id\u00e9ia \u00e9 primeiro criar uma caixa de texto e uma image com o gr\u00e1fico
  //sobre o fundo original escurecido
  textFont(fontText,18);
  etapaEnd=false;
  Temp.setData(temperatura);
  Comp1.setData(100-composicao); 
  Comp2.setData(composicao);

  /*if(flow==true){
   text("true", 40,40); 
   }else  text("false", 40,40); */

  if(tipo==1) {
    // flow=true;  
    //faz a regra da alavanca colorida 

    if((fase=="L\u00cdQUIDO+ALFA")) {
      patternLine(PApplet.parseInt(linha1),PApplet.parseInt(ycursor), PApplet.parseInt(linha1), 539, 0x5555, 4);    

      patternLine(PApplet.parseInt(linha2),PApplet.parseInt(ycursor), PApplet.parseInt(linha2), 539, 0x5555, 4);
      stroke(54,210,70);
      fill(54,210,70);
      textFont(fontText,14);
      text("P", (xcursor+linha1)/2, 462);  
      line(linha1, 462, xcursor, 462);
      fill(210,54,70);
      text("Q", (linha2+xcursor)/2, 462);  

      fill(0);
      textFont(fontText,12);
      text("C", linha1-8, 537);
      text("C", linha2+6, 537);
      text("C", xcursor+5, 537);
      sub("L",fontText,14, linha1-1, 539);
      sub("\u03b1",fontText,14, linha2+13, 539);
      sub("0",fontText,14, xcursor+10, 539);

      stroke(210,54,70);
      line(xcursor, 462,linha2, 462);
      fill(0);
      stroke(0);
      textFont(fontText);
    }       
    patternLine(PApplet.parseInt(xcursor),PApplet.parseInt(ycursor), PApplet.parseInt(xcursor), 539, 0x5555, 4); 
    if(etapa==2&&flow==false) {
      line(PApplet.parseInt(xcursor),PApplet.parseInt(ycursor),355, PApplet.parseInt(ycursor));
      patternLine(354,PApplet.parseInt(ycursor), 354, 539, 0x5555, 4);
    }
    if((etapa==5)&&(flow==false)) {
      line(PApplet.parseInt(xcursor), PApplet.parseInt(ycursor), 220, PApplet.parseInt(ycursor));  
      patternLine(220,PApplet.parseInt(ycursor), 220, 539, 0x5555, 4); 
      patternLine(220,PApplet.parseInt(ycursor), 70, PApplet.parseInt(ycursor), 0x5555, 4);
    }
    textFont(fontText,11);
    pushMatrix();
    translate(170,360);
    rotate(-PI/6);
    popMatrix();
    show = g.get(170, 290, 201, 270);

    //retangulo branco
    fill(15, 50);
    rect(0, 0, width, height);
    fill(255,240);
    rect(70,70,608, 469);
    fill(0);

    textFont(fontText,16);
    textLeading(16);
    textAlign(LEFT);

    image(show, 71,140, show.width*1.2f, show.height*1.2f);

    //0: fase liquida
    if(etapa==0) {
      xcursor = 283;
      ycursor = 304;
      text(polyExplain[0][lang]
        ,325, 135,320, 1000);
    }
    //1:comeco da precipitacao
    if(etapa==1) {
      text(polyExplain[1][lang]
        ,325, 135,320, 1000);  

      if(flow==true) {
        redraw();
        if(ycursor<335) { 
          ycursor+=1; //o cursor cai suavemente
        }
        else flow=false;
      }
      else {
        patternLine(207,195, 69, 195, 0x5555, 4);
        pushStyle();
        textFont(fontButton,12);
        text("1261",  42,200);
        popStyle();
        xcursor = 283;
        ycursor=335;
      }
    }
    //2:precipitacao, regra da alavanca
    if(etapa==2) {
      //temperatura

      text(polyExplain[2][lang]       
        ,325, 135,320, 1000);

      if(flow==true) {
        if(ycursor<335) { 
          ycursor+=1; //o cursor cai suavemente
        }
        else flow=false;
      }
      else {
        patternLine(207,195, 69, 195, 0x5555, 4);
        pushStyle();
        textFont(fontButton,12);
        text("1261",  42,200);
        text("46", 285,451);
        popStyle();
        xcursor = 283;
        ycursor=335;
      }
    }

    if(etapa==3) {
      fill(0);
      //   "Para uma temperatura infinitesimalmente\n"
      text(polyExplain[3][lang]
        ,325, 135,320, 1000);

      if(flow==true) {
        if(ycursor<=352) { 
          ycursor+=1; //o cursor cai suavemente
        }
        else flow=false;
      }
      else {
        xcursor = 283;
        ycursor=352;
      }
    }

    if(etapa==4) {
      fill(0);
      //   "Para uma temperatura infinitesimalmente\n"
      text(polyExplain[4][lang]
        ,325, 135,320, 1000);
      fill(0);

      sub("0",fontText,16, 607, 155);  
      sub("0",fontText,16, 413,171);
      sub("L",fontText,16, 441,171);
      sub("\u03b1",fontText,16, 508,171);
      sub("0",fontText,16, 537,171);

      sub("\u03b1",fontText,16, 570,187);
      sub("L",fontText,16, 609,187);

      sub("\u03b1",fontText,20, 340,240);
      sub("L",fontText,20, 340,286);

      div("P", "P+Q", 396,230);
      div("Q", "P+Q", 396,280); 

      if(flow==true) {
        if(ycursor<352) { 
          ycursor+=1; //o cursor cai suavemente
        }
        else flow=false;
      }
      else {
        ycursor=352;
      }
    }  

    //4:solidificacao
    if(etapa==5) {
      //   "Para uma temperatura infinitesimalmente\n"
      text(polyExplain[5][lang],325, 135,320, 1000);

      if(flow==true) {
        if(ycursor<371) { 
          ycursor+=1; //o cursor cai suavemente
        }
        else flow=false;
      }
      else {

        xcursor = 283;
        ycursor=371.7f;
      }
    }

    //5:fase solida
    if((etapa==6)) {
      etapaEnd=true;
      text(polyExplain[6][lang],325, 135,320, 1000);
      //ycursor=369;
      if(flow==true) {
        if(ycursor<393) { 
          ycursor+=1;//o cursor cai suavemente
        }
        else flow=false;//transicao suave
      }
      else {
        ycursor=393;
      }
    }
    if(etapa>6) etapa=6;

    //novos eixos
    textFont(fontButton,12);
    //temperatura
    text("1000",  42,442);
    text("1100",  42,350);
    text("1200",  42,253);
    text("1300",  42,162);
    //composicao
    text("20", 93,451);
    text("40", 237, 451);

    if(fase!="L\u00cdQUIDO+ALFA") {
      text("35", 200,451);
    }
    if((etapa==5)&&(flow==false)) {
      text("1214", 42,241);
      text("24", 125,451);
    }
    textFont(fontButton,18);
    text(polyScreen[7][lang], 112,472);
    textAlign(LEFT);
    pushMatrix();
    rotate(-PI/2);
    text(polyControl[0][lang], -displayaco.width/2+10, 30) ;
    popMatrix();
  }

  ////////Pb-Sn////////////
  if(tipo==2) {
    patternLine(83, 70, 83, 500,  0x5555, 4);       
    patternLine(179, 70,179, 500, 0x5555, 4); 
    patternLine(PApplet.parseInt(446.5f), 70, PApplet.parseInt(446.5f), 500, 0x5555, 4);  
    patternLine(PApplet.parseInt(661), 70, PApplet.parseInt(661),500, 0x5555, 4); 
    patternLine(PApplet.parseInt(670), 70, PApplet.parseInt(670),500, 0x5555, 4); 
    textFont(fontText,16);
    textLeading(16);
    fill(0);
    text("C", 84,510);
    sub("1",fontText,16, 92,511);   //look here
    text("C", 184,510);
    sub("2",fontText,16, 192,511); 
    text("C",447,510);
    sub("3",fontText,16, 455,511); 
    text("C", 655,510);
    sub("4",fontText,16, 663,511); 
    text("C", 672,510);
    sub("5",fontText,16, 681,511); 
    
    if((etapa == 4)||(etapa==5)) {
      fill(177,17,23);
      textFont(fontText, 16);
      pushMatrix();
      translate(130, 328);
      rotate(-PI/4);
      text("Solvus", 0, 0);
      popMatrix();
    }
    
    if((etapa>=6)&&(etapa<=9)) {
      show = g.get(520, 70, 180, 469);
    }
    else if(etapa <6) show = g.get(PApplet.parseInt(xcursor)-70, 70, 201, 469);

    if((etapa == 10)||(etapa== 11)) {
      show = g.get(PApplet.parseInt(xcursor)-80, 70, 200, 469);
    }
    if(etapa>=12) show = g.get(PApplet.parseInt(xcursor)-113, 70, 230, 469); 

    fill(15, 50);
    rect(0, 0, width, height);
    fill(255,240);
    rect(70,70,608, 469);
    textAlign(LEFT);
    fill(0);

    //0:L\u00cdQUIDO
    if(etapa==0) {
      xcursor = 448;
      ycursor = 292;
      textFont(fontText,14);
      textLeading(14);
      text( polyExplain[7][lang]        
        ,80, 95,210, 1000);
      image(exp1,295,113, 380,310);
      flow=false;
    }
    if(etapa==1) {
      xcursor = 448;
      ycursor = 292;
      textFont(fontText,14);
      textLeading(14);
      text(polyExplain[8][lang]
        ,80, 135,210, 1000);
      image(exp2,285,113, 380,310);
      flow=false;
    }

    textFont(fontText,14);
    textLeading(14);

    if(etapa==2) {
      text(polyExplain[9][lang]
        ,325, 135,320, 1000);
      sub("liga",fontText,16, 426,180); 
      sub("liga",fontText,16, 396,249  ); 
      sub("1",fontText,16, 435,249); 
      sub("1",fontText,16, 497,249);

      xcursor = 83;
      ycursor = 99;
      flow=false;
    }

    if(etapa==3) {      
      text(polyExplain[9][lang]
        ,325, 135,320, 1000);
      sub("liga",fontText,16, 426,180); 
      sub("liga",fontText,16, 396,249  ); 
      sub("1",fontText,16, 435,249); 
      sub("1",fontText,16, 497,249);

      if(flow==true) {
        if(ycursor<467) { 
          ycursor+=3; //o cursor cai suavemente
        }
        else flow=false;
      }
      else {
        xcursor =83;
        ycursor=467;
        flow=false;
      }
    }

    if(etapa==4) {
      xcursor = 131;
      ycursor=116;

      text(polyExplain[10][lang]
        ,325, 135,320, 1000);
      sub("1",fontText,16, 369,152);   //look here
      sub("liga",fontText,16, 400,152);   //look here
      sub("2",fontText,16, 437,152);   //look here
      if(flow==true) {
        if(ycursor<154) { 
          ycursor+=3; //o cursor cai suavemente
        }
        else {
          flow=false;
          ycursor=154;
        }
      }        
      else {
        flow=false;
        ycursor=154;
      }
    }

    if((etapa==5)) {
      text(polyExplain[10][lang]
        ,325, 135,320, 1000);
      sub("1",fontText,16, 369,152);   //look here
      sub("liga",fontText,16, 400,152);   //look here
      sub("2",fontText,16, 437,152);   //look here

      if(flow==true) {
        if(ycursor<418) { 
          ycursor+=3;//o cursor cai suavemente
        }
        else {
          flow=false;//transicao suave
          xcursor = 131;
          ycursor=418;
        }
      }        
      else {
        xcursor = 131;
        ycursor=418;
      }
    }

    if(etapa==6) {
      xcursor = 670;
      ycursor=116;
      text( polyExplain[22][lang],325, 135,320, 1000);
      sub("5",fontText,16, 336,179);   //look here
      sub("liga",fontText,16, 367,179);   //look here
      sub("5",fontText,16, 513,179);   //look here
      flow=false;
    }


    if(etapa==7) {
      if(flow==true) {
        if(ycursor<467) { 
          ycursor+=3; //o cursor cai suavemente
        }
        else flow=false;
      }
      else {
        xcursor = 670;
        ycursor=467;
        flow=false;
      }
      text( polyExplain[22][lang],325, 135,320, 1000);
    sub("5",fontText,16, 336,179);   //look here
      sub("liga",fontText,16, 367,179);   //look here
      sub("5",fontText,16, 513,179);   //look here
    }

    if(etapa==8) {
      xcursor = 665;
      ycursor=116;
      text(polyExplain[24] [lang],325, 135,320, 1000);
      sub("4",fontText,16, 368,152);   //look here
      sub("liga",fontText,16, 399,152);   //look here
      sub("5",fontText,16, 440,152);   //look here
      flow=false;
    }

    if(etapa==9) {
      if(flow==true) {
        if(ycursor<467) { 
          ycursor+=3; //o cursor cai suavemente
        }
        else flow=false;
      }
      else {
        xcursor =665;
        ycursor=467;
        flow=false;
      }
      text(polyExplain[25][lang],325, 135,320, 1000);
      sub("4",fontText,16, 368,152);   //look here
      sub("liga",fontText,16, 399,152);   //look here
      sub("5",fontText,16, 440,152);   //look here
    }

    if((etapa==10)) { //7
      xcursor=446.2f;
      ycursor=261;
      sub("liga",fontText,16, 336,180);   //look here
      sub("3",fontText,16, 377,180);   //look here
      sub("3",fontText,16, 417,236);   //look here
      sub("2",fontText,16, 455,249);   //look here
      sub("4",fontText,16, 352,265);   //look here
      textFont(fontText,14);
      textLeading(14);
      text(polyExplain[11][lang],325, 135,320, 1000);
      //ycursor=369;
      if(flow==true) {
        if(ycursor<304) { 
          ycursor+=2;//o cursor cai suavemente
        }
        else flow=false;//transicao suave
      }
      else {
        xcursor=446.2f;
        ycursor=418;
        flow=false;
      }
    }
    if(etapa==11) {
      //ycursor=352;
      text(polyExplain[11][lang],325, 135,320, 1000);
      sub("liga",fontText,16, 336,180);   //look here
      sub("3",fontText,16, 377,180);   //look here
      sub("3",fontText,16, 417,236);   //look here
      sub("2",fontText,16, 455,249);   //look here
      sub("4",fontText,16, 352,265);   //look here
      if(flow==true) {
        if(ycursor<304) { 
          ycursor+=2; //o cursor cai suavemente
        }
        else flow=false;
      }
      else {
              xcursor=446.2f;
        ycursor=304;
        flow=false;
      }
    }

    if((etapa==12)) {
      xcursor = 251.7f;
      ycursor = 171;

      fill(0);
      text(polyExplain[12][lang],325, 135,320, 1000);
      sub("2",fontText,16, 335,179);   //look here
      sub("liga",fontText,16, 366,179);   //look here
      sub("3",fontText,16, 407,179);   //look here
    }
    if((etapa==13)) {
      text(polyExplain[12][lang]
        ,325, 135,320, 1000);
      sub("2",fontText,16, 335,179);   //look here
      sub("liga",fontText,16, 366,179);   //look here
      sub("3",fontText,16, 407,179);   //look here
      //ycursor=369;
      if(flow==true) {
        if(ycursor<290) { 
          ycursor+=2;//o cursor cai suavemente
        }
        else flow=false;//transicao suave
      }
      else {
              xcursor = 251.7f;
        ycursor=290;
        flow=false;
      }
    }

    if((etapa==14)) {
      fill(0);
      text(polyExplain[13][lang]
        ,325, 135,320, 1000);
      sub("2",fontText,16, 482,166);   //look here
      sub("liga",fontText,16, 431+81,166);   //look here
      sub("3",fontText,16, 472+81,166);   //look here

      if(flow==true) {
        if(ycursor<303) { 
          ycursor+=1;//o cursor cai suavemente
        }
        else flow=false;//transicao suave
      }
      else {
              xcursor = 251.7f;
        ycursor=303;
        flow=false;
      }
    }

    if((etapa==15)) {
      xcursor = 550;
      ycursor = 171; 
      fill(0);


      text(polyExplain[26][lang], 325, 135,320, 1000);
            sub("3",fontText,16, 335,179); 
      sub("liga",fontText,16, 366,179);   //look here
      sub("4",fontText,16, 407,179);   //look here
    }

    if((etapa==16)) {
      fill(0);
      text(polyExplain[26][lang],325, 135,320, 1000);
      sub("3",fontText,16, 335,179); 
      sub("liga",fontText,16, 366,179);   //look here
      sub("4",fontText,16, 407,179);   //look here
      if(flow==true) {
        if(ycursor<290) { 
          ycursor+=2;//o cursor cai suavemente
        }
        else flow=false;//transicao suave
      }
      else {
        xcursor = 550;
        ycursor=290;
        flow=false;
      }
    }

    if((etapa==17)) {
      fill(0);
      etapaEnd=true;
      text("Para temperaturas imediatamente inferiores \u00e0 "+
          "temperatura eut\u00e9tica e C  < C     < C , a "+
          "micro- estrutura do s\u00f3lido \u00e9 composta de "+
          "part\u00edculas do s\u00f3lido \u03b2 proeut\u00e9tico, imersas em "+
          "um s\u00f3lido de microestrutura eut\u00e9tica."
        ,325, 135,320, 1000);
      sub("3",fontText,16, 482,166);   //look here
      sub("liga",fontText,16, 512,166);   //look here
      sub("4",fontText,16, 553,166);   //look here
      if(flow==true) {
        if(ycursor<303) { 
          ycursor+=1;//o cursor cai suavemente
        }
        else flow=false;//transicao suave
      }
      else {
        xcursor = 550;
        ycursor=303;
        flow=false;
      }
    }
    if(etapa>17) etapa=17;

    if(etapa>=2) { 
      image(show,71,140, 201, 324);

      //novos eixos
      textFont(fontButton,12);
      //temperatura
      text("100",  50,373);
      text("200",  50,282);
      text("300",  50,187);

      if((etapa==2)||(etapa==3)) {
        //composicao
        text("0", 127,475);
        text("10", 186, 475);
        text("20", 245,475);
      }

      //composicao
      if((etapa==4)||(etapa==5)) {
        text("0",76,475);
        text("10", 134, 475);
        text("20", 194,475);
        text("30", 254,475);
      }
      if((etapa>=6)&&(etapa<=9)) {
        text("80", 105,475);
        text("90", 173, 475);
        text("100", 240,475);
      }
      if((etapa==10)||(etapa==11)) {
        text("60", 132,475);
        text("70", 192, 475);
        text("80", 250,475);
      }
      if((etapa==12)||(etapa==13)||(etapa==14)) {
        text("20", 109, 475);
        text("30", 165,475);
        text("40", 218, 475);
      }
      if((etapa==15)||(etapa==16)||(etapa==17)) {
        text("70", 114, 475);
        text("80", 168,475);
        text("90", 221,475);
      }

      textFont(fontButton,18);
      text( polyScreen[8][lang], 110,500);
      textAlign(LEFT);
      pushMatrix();
      rotate(-PI/2);

      text(polyControl[0][lang], -displayaco.width/2+10, 30) ;
      popMatrix();
    }
  }


  //////FE3C//////////
  if(tipo==3) {
    textFont(fontText,12);
    textLeading(12);
    fill(0);
    //flow=true;   //wut
    if((etapa==5)||(etapa==6)||(etapa==7)||(etapa==8)) {
      patternLine(100, 350,100, 540, 0x5555, 4);  
      text("C", 96,345);
      sub("1",fontText,12, 103,347);   //look here
      textFont(fontText,10);
      textLeading(10);
      fill(177,17,23);
      pushMatrix();
      translate(118,392);
      rotate(PI/4.5f);
      text("Solvus", 0, 0);
      popMatrix();
    }

    if((etapa==3)||(etapa==4)) {
      patternLine(139, 350, 139, 540,  0x5555, 4);  
      text("C", 135,345);
      sub("2",fontText,12, 143,347);
    }
    if((etapa==9)||(etapa==10)) {
      patternLine(180, 350,179, 540, 0x5555, 4); 
      text("C",175,345);
      sub("3",fontText,12, 182,347); 

      textFont(fontText,10);
      textLeading(10);
      fill(177,17,23);
      pushMatrix();
      translate(150,392);
      rotate(-PI/3.5f);
      text("Solvus", 0, 0);
      popMatrix();
    }
    if(etapa>10) {
      patternLine(463,120, 463, 540,  0x5555, 4); 
      text("C", 655,510);
      sub("4",fontText,12, 660,511);
    }

    fill(177,17,23);
    textSize(12);
    text("\u03b3", 115, 348);
    text("\u03b3+Fe\u2083C", 195, 380);
    text("\u03b1+Fe\u2083C", 140,500);
    fill(0);

    if((etapa==11)||(etapa==12)) { 
      show = g.get(390, 180, 160,208 );
    }
    else if(etapa>12) {
      show = g.get(390, 260, 160,208 );
    }
    else show = g.get(70, 332, 160, 208);
    fill(15, 50);
    rect(0, 0, width, height);
    fill(255,240);
    rect(70,70,608, 469);
    fill(0);

    textAlign(LEFT); 
    textFont(fontText,16);
    textLeading(16);

    if(etapa==0) {
      image(exp3, 71,71, 607, 468);
      xcursor = 140;
      ycursor = 410;
      fase = "TRANSI\u00c7\u00c3O\nDE FASES";
    }

    if(etapa==1) {
      image(exp4, 72, 117, 361, 286);
      text(polyExplain[28][lang]
        ,437, 95,226, 1000);
      xcursor = 140;
      ycursor = 410;
    }

    if(etapa==2) {
      image(exp5,  72, 117, 361, 286);
      text(polyExplain[29][lang],437, 115,226, 1000);
      sub("1",fontText,16, 568,230);
      sub("2",fontText,16, 596,230);
      sub("3",fontText,16, 625,230);
      sub("4",fontText,16, 462,247);
      xcursor = 140;
      ycursor = 410;
    }

    //eutet\u00f3ide
    if(etapa==3) {
      xcursor = 139;
      ycursor = 360;
      sub("2",fontText,16, 426,187); 
      text(polyExplain[15][lang]
        ,325, 135,320, 1000);
    }

    if(etapa==4) {
      sub("2",fontText,16, 426,187); 
      if(flow==true) {
        if(ycursor<412) ycursor+=1;//o cursor cai suavemente
        else flow=false;
      }else{
           xcursor = 139;
           ycursor = 412;
        }
      text(polyExplain[15][lang]
        ,325, 135,320, 1000);
    }

    if(etapa==5) {
      xcursor = 100;
      ycursor = 357;
      sub("1",fontText,16, 593,173); 
      //   "Para uma liga ferro-carbono de composi\u00e7\u00e3o\n"
      text(polyExplain[16][lang]
        ,325, 135,320, 1000);
    }

    if(etapa==6) {
      text(polyExplain[17][lang]
        ,325, 135,320, 1000);

      if(flow==true) {
        if(ycursor<381) { 
          ycursor+=1; //o cursor cai suavemente
        }     
        else flow=false;
      }
      else {
        xcursor = 100;
        ycursor=381;
        flow=false;
      }
    }
    if(etapa==7) {
      text(polyExplain[17][lang]
        ,325, 135,320, 1000);
      if(flow==true) {
        if(ycursor<404) ycursor+=1; //o cursor cai suavemente
        else flow=false;
      }
      else {
        xcursor = 100;
        ycursor=404;
        flow=false;
      }
    }

    if(etapa==8) {
      text(polyExplain[18][lang],325, 135,320, 1000);
      if(flow==true) {
        if(ycursor<412) ycursor+=1; //o cursor cai suavemente
        else flow=false;
      }
      else {
        xcursor = 100;
        ycursor=412;
        flow=false;
      }
    }

    if(etapa==9) {
      sub("1",fontText,16, 427,187); 
      sub("3",fontText,16, 657,187); 
      xcursor= 180;
      ycursor= 348;
      flow=false;
      text(polyExplain[19][lang],325, 135,340, 1000);
    }

    if(etapa==10) {
      sub("1",fontText,16, 427,187); 
      sub("3",fontText,16, 657,187); 
      text(polyExplain[19][lang],325, 135,340, 1000);
      if(flow==true) {
        if(ycursor<412) ycursor+=1;//o cursor cai suavemente
        else flow=false;
      }
      else {
        xcursor= 180;
        ycursor=412;
        flow=false;
      }
    }


    if(etapa==11) {
      xcursor= 463;
      ycursor= 218;
      text(polyExplain[20][lang]
        ,325, 135,320, 1000);
    }

    if(etapa==12) {
      text(polyExplain[20][lang]
        ,325, 135,320, 1000);
      if(flow==true) {
        if(ycursor<386) ycursor+=3;//o cursor cai suavemente
        else flow=false;
      }
      else {      
        xcursor= 463;
        ycursor=386;
      }
    } 

    if(etapa==13) {
      etapaEnd=true;
      text(polyExplain[21][lang]
        ,325, 135,320, 1000);
      if(flow==true) {
        if(ycursor<414) ycursor+=2;//o cursor cai suavemente
        else flow=false;
      }
      else {
        xcursor= 463;
        ycursor=414;
      }
    } 
    if(etapa>13) etapa=13;
    if(etapa>2) image(show, 71,140, show.width*1.2f, show.height*1.2f);

    //novos eixos
    if(etapa>10) {
      textFont(fontButton,12);
      text("1000",  43,388);
      text("1100",  43,290);
      text("1200",  43,197);

      //composicao
      text("4", 117,400);
      text("5", 229, 400);    

      textFont(fontButton,18);
      text(polyScreen[9][lang], 87,416);
      textAlign(LEFT);
      pushMatrix();
      rotate(-PI/2);

      text(polyControl[0][lang], -displayaco.width/2+10, 30) ;
      popMatrix();
    }
    
    else if(etapa>=3) {
      textFont(fontButton,12);
      //temperatura
      text("400",  50,388);
      text("500",  50,300);
      text("600",  50,204);

      //composicao
      text("0", 70,400);
      text("1", 176, 400);    

      textFont(fontButton,18);
      text(polyScreen[9][lang], 87,416);
      textAlign(LEFT);
      pushMatrix();
      rotate(-PI/2);
      text(polyControl[0][lang], -displayaco.width/2+10, 30) ;
      popMatrix();
    }
  }
}

// desenha gr\u00e3os ap\u00f3s o crescimento, controlando o tamanho deles (para o diagrama do Fe); tamanho
// \u00e9 a \u00e1rea relativa ocupada pelos gr\u00e3os(assim, teremos um scale de raizde_tamanho
public void DrawGrao(PGraphics pg, int tipo, float tamanho){
  pg.beginDraw();
  if(tipo == 0){
    pg.pushMatrix();
    pg.scale(sqrt(tamanho));
    pg.beginShape();
    pg.vertex(1.0f, 44.0f);
    pg.bezierVertex(1.0f, 44.0f, 27.0f, 51.0f, 30.0f, 42.0f);
    pg.bezierVertex(33.0f, 33.0f, 49.0f, 34.0f, 46.0f, 23.0f);
    pg.bezierVertex(43.0f, 12.0f, 47.0f, 1.0f, 47.0f, 1.0f);
    pg.bezierVertex(47.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f);
    pg.bezierVertex(0.0f, 0.0f, 0.0f, 43.0f, 0.0f, 43.0f);
    pg.endShape();
    pg.popMatrix();
  }

  if(tipo == 1){
    pg.pushMatrix();
    pg.translate(100 - 100*tamanho, 0); //ok
    pg.scale(sqrt(tamanho));
    pg.beginShape();
    pg.vertex(40.0f, 32.0f);
    pg.bezierVertex(40.0f, 32.0f, 50.0f, 44.0f, 59.0f, 48.0f);
    pg.bezierVertex(68.0f, 52.0f, 57.0f, 44.0f, 69.0f, 52.0f);
    pg.bezierVertex(81.0f, 60.0f, 82.0f, 61.0f, 84.0f, 60.0f);
    pg.bezierVertex(86.0f, 59.0f, 100.0f, 59.0f, 100.0f, 59.0f);
    pg.bezierVertex(100.0f, 59.0f, 100.0f, -1.0f, 100.0f, 0.0f);
    pg.bezierVertex(100.0f, 1.0f, 46.0f, -1.0f, 46.0f, 0.0f);
    pg.bezierVertex(46.0f, 1.0f, 43.0f, 25.0f, 47.0f, 26.0f);
    pg.bezierVertex(51.0f, 27.0f, 40.0f, 31.0f, 40.0f, 32.0f);
    pg.endShape();
    pg.popMatrix();
  }
  if(tipo == 2){
    pg.pushMatrix();
    pg.translate(100 - 100*tamanho, 100 - 100*tamanho);
    pg.scale(sqrt(tamanho));

    pg.beginShape();
    pg.vertex(57.0f, 47.0f);
    pg.bezierVertex(57.0f, 47.0f, 45.0f, 65.0f, 45.0f, 69.0f);
    pg.bezierVertex(45.0f, 73.0f, 41.0f, 83.0f, 42.0f, 91.0f);
    pg.bezierVertex(43.0f, 99.0f, 43.0f, 100.0f, 43.0f, 100.0f);
    pg.bezierVertex(43.0f, 100.0f, 100.0f, 99.0f, 100.0f, 100.0f);
    pg.bezierVertex(100.0f, 101.0f, 101.0f, 58.0f, 101.0f, 58.0f);
    pg.bezierVertex(101.0f, 58.0f, 85.0f, 58.0f, 84.0f, 61.0f);
    pg.bezierVertex(83.0f, 64.0f, 63.0f, 46.0f, 63.0f, 49.0f);
    pg.bezierVertex(63.0f, 52.0f, 57.0f, 47.0f, 57.0f, 47.0f);
    pg.endShape();
    pg.popMatrix();
  }
  if (tipo == 3){ 
    pg.pushMatrix();
    pg.translate(0, 100 - 100*tamanho);
    pg.scale(sqrt(tamanho));
    pg.beginShape();
    pg.vertex(41.0f, 33.0f);
    pg.bezierVertex(41.0f, 33.0f, 57.0f, 50.0f, 57.0f, 47.0f);
    pg.bezierVertex(57.0f, 44.0f, 43.0f, 69.0f, 45.0f, 69.0f);
    pg.bezierVertex(47.0f, 69.0f, 39.0f, 86.0f, 43.0f, 92.0f);
    pg.bezierVertex(47.0f, 98.0f, 44.0f, 100.0f, 44.0f, 100.0f);
    pg.bezierVertex(44.0f, 100.0f, 0.0f, 100.0f, 0.0f, 100.0f);
    pg.bezierVertex(0.0f, 100.0f, 1.0f, 43.0f, 1.0f, 43.0f);
    pg.bezierVertex(1.0f, 43.0f, 17.0f, 50.0f, 25.0f, 46.0f);
    pg.bezierVertex(33.0f, 42.0f, 25.0f, 46.0f, 25.0f, 46.0f);
    pg.bezierVertex(25.0f, 46.0f, 40.0f, 32.0f, 41.0f, 30.0f);
    pg.endShape();
    pg.popMatrix();
  }
  pg.endDraw();
}


public void cresceGrao(float W2, PGraphics pg, boolean led){
  pg.pushMatrix(  ); 
  pg.scale(1.6f);
  pg.translate(-2,-5);
  pg.stroke(0);
  Agrao = PI*1.5f*1.5f*(raio[0]*raio[0]*2 + raio[1]*raio[1]*2 +raio[2]*raio[2]+raio[3]*raio[3]*2);
  raioupdate(Agrao, W2);
  
  grao(15.0f, 15.0f,raio[0], 1, pg);
  grao(47.0f,15.0f,raio[1],2, pg);
  grao(37.0f,35.0f,raio[3],0, pg);
  grao(10.0f, 40.0f,raio[2],0, pg);
  grao(64.0f,30.0f,raio[1],0, pg);
  grao(25.0f,61.0f,raio[3],1, pg);
  grao(53.0f,58.0f,raio[0],0, pg);
  pg.popMatrix();
}

//atualiza o raio at\u00e9 que a \u00e1rea dos gr\u00e3os ocupe a imagem na propor\u00e7\u00e3o certa
public void raioupdate(float agrao, float razao){
  if(razao<=0){
    raio[0] = 0;
    raio[1] = 0;
    raio[2] = 0;
    raio[3] = 0;
  }
  else{
    while((agrao/(13000)<razao)){
      raio[0] += 0.2f;
      raio[1] += 0.225f;
      raio[2] += 0.25f;
      raio[3] += 0.2f;
      agrao = PI*1.5f*1.5f*(raio[0]*raio[0]*2 + raio[1]*raio[1]*2 +raio[2]*raio[2]+raio[3]*raio[3]*2);
    }
    while((agrao/(13000)>razao)){
      raio[0] -= 0.2f;
      raio[1] -= 0.225f;
      raio[2] -= 0.25f;
      raio[3] -= 0.2f;
      agrao = PI*1.5f*1.5f*(raio[0]*raio[0]*2 + raio[1]*raio[1]*2 +raio[2]*raio[2]+raio[3]*raio[3]*2);
    }
  }
}


public void grao(float xpos, float ypos, float raio, int tipo, PGraphics pg){
  pg.pushMatrix();
  pg.translate(xpos, ypos);
  pg.scale(raio/50);
  
  if(tipo == 0){
    pg.beginShape();
    pg.vertex(18.0f, -52.0f);
    pg.bezierVertex(30.0f, -50.0f, 40.0f, -43.0f, 46.0f, -31.0f);
    pg.bezierVertex(52.0f, -19.0f, 52.0f, -22.0f, 51.0f, -12.0f);
    pg.bezierVertex(50.0f, -2.0f, 50.0f, 0.0f, 50.0f, 1.0f);
    pg.bezierVertex(50.0f, 2.0f, 49.0f, 13.0f, 44.0f, 20.0f);
    pg.bezierVertex(39.0f, 27.0f, 37.0f, 30.0f, 34.0f, 35.0f);
    pg.bezierVertex(31.0f, 40.0f, 20.0f, 47.0f, 22.0f, 45.0f);
    pg.bezierVertex(24.0f, 43.0f, 12.0f, 51.0f, 6.0f, 51.0f);
    pg. bezierVertex(0.0f, 51.0f, -1.0f, 47.0f, -1.0f, 47.0f);
    pg.bezierVertex(-1.0f, 47.0f, -10.0f, 43.0f, -13.0f, 43.0f);
    pg. bezierVertex(-16.0f, 43.0f, -24.0f, 36.0f, -25.0f, 34.0f);
    pg. bezierVertex(-26.0f, 32.0f, -42.0f, 21.0f, -41.0f, 22.0f);
    pg.bezierVertex(-40.0f, 23.0f, -46.0f, 10.0f, -45.0f, 11.0f);
    pg. bezierVertex(-44.0f, 12.0f, -44.0f, 3.0f, -44.0f, 3.0f);
    pg.bezierVertex(-44.0f, 3.0f, -46.0f, -21.0f, -46.0f, -21.0f);
    pg. bezierVertex(-46.0f, -21.0f, -40.0f, -36.0f, -38.0f, -38.0f);
    pg. bezierVertex(-36.0f, -40.0f, -32.0f, -49.0f, -27.0f, -49.0f);
    pg.bezierVertex(-22.0f, -49.0f, -20.0f, -54.0f, -13.0f, -54.0f);
    pg.bezierVertex(-6.0f, -54.0f, -11.0f, -55.0f, -11.0f, -55.0f);
    pg.bezierVertex(-11.0f, -55.0f, 1.0f, -53.0f, 1.0f, -53.0f);
    pg.bezierVertex(1.0f, -53.0f, 18.0f, -52.0f, 17.0f, -52.0f);
    pg.endShape();
  }
  if(tipo==1){
    pg.beginShape();
    pg.vertex(18.0f, -52.0f);
    pg. bezierVertex(30.0f, -50.0f, 39.0f, -41.0f, 45.0f, -29.0f);
    pg. bezierVertex(51.0f, -17.0f, 49.0f, -21.0f, 51.0f, -11.0f);
    pg.bezierVertex(53.0f, -1.0f, 54.0f, -2.0f, 54.0f, -1.0f);
    pg.bezierVertex(54.0f, 0.0f, 49.0f, 13.0f, 44.0f, 20.0f);
    pg.bezierVertex(39.0f, 27.0f, 35.0f, 27.0f, 32.0f, 32.0f);
    pg.bezierVertex(29.0f, 37.0f, 21.0f, 41.0f, 22.0f, 45.0f);
    pg. bezierVertex(23.0f, 49.0f, 12.0f, 51.0f, 6.0f, 51.0f);
    pg. bezierVertex(0.0f, 51.0f, -1.0f, 47.0f, -1.0f, 47.0f);
    pg. bezierVertex(-1.0f, 47.0f, -10.0f, 43.0f, -13.0f, 43.0f);
    pg. bezierVertex(-16.0f, 43.0f, -16.0f, 41.0f, -23.0f, 38.0f);
    pg. bezierVertex(-30.0f, 35.0f, -28.0f, 39.0f, -39.0f, 30.0f);
    pg. bezierVertex(-50.0f, 21.0f, -41.0f, 30.0f, -47.0f, 23.0f);
    pg.bezierVertex(-53.0f, 16.0f, -48.0f, 19.0f, -51.0f, 0.0f);
    pg.bezierVertex(-54.0f, -19.0f, -46.0f, -21.0f, -46.0f, -21.0f);
    pg.  bezierVertex(-46.0f, -21.0f, -37.0f, -34.0f, -35.0f, -36.0f);
    pg. bezierVertex(-33.0f, -38.0f, -32.0f, -49.0f, -27.0f, -49.0f);
    pg.  bezierVertex(-22.0f, -49.0f, -20.0f, -54.0f, -13.0f, -54.0f);
    pg.  bezierVertex(-6.0f, -54.0f, -11.0f, -55.0f, -11.0f, -55.0f);
    pg.  bezierVertex(-11.0f, -55.0f, 1.0f, -53.0f, 1.0f, -53.0f);
    pg. bezierVertex(1.0f, -53.0f, 18.0f, -52.0f, 17.0f, -52.0f);
    pg. endShape();
  }
  if(tipo==2){
    pg.beginShape();
    pg.vertex(18.0f, -52.0f);
    pg. bezierVertex(30.0f, -50.0f, 39.0f, -41.0f, 45.0f, -29.0f);
    pg. bezierVertex(51.0f, -17.0f, 49.0f, -21.0f, 51.0f, -11.0f);
    pg.bezierVertex(53.0f, -1.0f, 54.0f, -2.0f, 54.0f, -1.0f);
    pg.bezierVertex(54.0f, 0.0f, 49.0f, 13.0f, 44.0f, 20.0f);
    pg.bezierVertex(39.0f, 27.0f, 35.0f, 27.0f, 32.0f, 32.0f);
    pg. bezierVertex(29.0f, 37.0f, 21.0f, 41.0f, 22.0f, 45.0f);
    pg. bezierVertex(23.0f, 49.0f, 12.0f, 51.0f, 6.0f, 51.0f);
    pg.bezierVertex(-1.0f, 47.0f, -2.0f, 48.0f, -2.0f, 41.0f);
    pg.bezierVertex(-2.0f, 34.0f, -5.0f, 36.0f, -12.0f, 33.0f);
    pg.bezierVertex(-19.0f, 30.0f, -11.0f, 32.0f, -22.0f, 23.0f);
    pg.bezierVertex(-33.0f, 14.0f, -30.0f, 20.0f, -36.0f, 13.0f);
    pg.bezierVertex(-42.0f, 6.0f, -48.0f, 19.0f, -51.0f, 0.0f);
    pg. bezierVertex(-54.0f, -19.0f, -46.0f, -21.0f, -46.0f, -21.0f);
    pg.bezierVertex(-46.0f, -21.0f, -37.0f, -34.0f, -35.0f, -36.0f);
    pg. bezierVertex(-33.0f, -38.0f, -32.0f, -49.0f, -27.0f, -49.0f);
    pg. bezierVertex(-22.0f, -49.0f, -22.0f, -53.0f, -13.0f, -54.0f);
    pg.bezierVertex(-4.0f, -55.0f, -21.0f, -51.0f, -11.0f, -55.0f);
    pg. bezierVertex(-1.0f, -59.0f, -9.0f, -61.0f, 0.0f, -62.0f);
    pg.bezierVertex(9.0f, -63.0f, 18.0f, -52.0f, 17.0f, -52.0f);
    pg.endShape();
  }
  pg.popMatrix();
}


//based on Bresenham's algorithm from wikipedia
//http://en.wikipedia.org/wiki/Bresenham's_line_algorithm

public void patternLine(int xStart, int yStart, int xEnd, int yEnd, int linePattern, int lineScale) {
  int temp, yStep, x, y;
  int pattern = linePattern;
  int carry;
  int count = lineScale;

  boolean steep = (abs(yEnd - yStart) > abs(xEnd - xStart));
  if (steep == true) {
    temp = xStart;
    xStart = yStart;
    yStart = temp;
    temp = xEnd;
    xEnd = yEnd;
    yEnd = temp;
  }    
  if (xStart > xEnd) {
    temp = xStart;
    xStart = xEnd;
    xEnd = temp;
    temp = yStart;
    yStart = yEnd;
    yEnd = temp;
  }
  int deltaX = xEnd - xStart;
  int deltaY = abs(yEnd - yStart);
  int error = - (deltaX + 1) / 2;

  y = yStart;
  if (yStart < yEnd) {
    yStep = 1;
  } 
  else {
    yStep = -1;
  }
  for (x = xStart; x <= xEnd; x++) {
    if ((pattern & 1) == 1) {
      if (steep == true) {
        point(y, x);
      } 
      else {
        point(x, y);
      }
      carry = 0x8000;
    } 
    else {
      carry = 0;
    }  
    count--;
    if (count <= 0) {
      pattern = (pattern >> 1) + carry;
      count = lineScale;
    }

    error += deltaY;
    if (error >= 0) {
      y += yStep;
      error -= deltaX;
    }
  }
}


//idioma
String[][] polyExplain = new String[30][2];  
String[][] polyControl = new String[17][2];    
String[][] polyScreen = new String[13][2];
String[][] polyTable = new String[10][2];

public void setText() { //sets the  texts 
  //Texts shown in the Splash Scren and in the Credits

  polyScreen[0][0]= "DIAGRAMAS DE FASES";
  polyScreen[0][1]="PHASE DIAGRAMS"; 
  polyScreen[1][0] ="Apresentamos nesta simula\u00e7\u00e3o interativa, correla\u00e7\u00f5es entre a temperatura,\n"+
    "a composi\u00e7\u00e3o qu\u00edmica e a microestrutura de sistemas bin\u00e1rios em equil\u00edbrio\n"+
    "termodin\u00e2mico, correspondentes \u00e0 tr\u00eas tipos de diagramas de fase: um isomorfo\n"+
    "(ou de solu\u00e7\u00e3o s\u00f3lida), um eut\u00e9tico e o diagrama do sistema Fe-Fe\u2083C, que possui\n"+
    "uma transforma\u00e7\u00e3o eutet\u00f3ide\n";
  polyScreen[1][1]="This interactive animation presents correlations between\n"+
    "temperature, chemical composition and microstructure of binary\n"+
    "systems in thermodynamic equilibrium corresponding to three different\n"+
    "types of phase diagrams: isomorphous (or solid solution), eutectic\n"+
    "and the Fe-Fe\u2083C system diagram, which possess an eutectoid transformation"; //obviously, this is an highly preliminary tentative of translation



  polyScreen[2][0] = "SELECIONE O DIAGRAMA DE INTERESSE";
  polyScreen[2][1] = "SELECT THE DIAGRAM OF INTEREST";

  polyScreen[3][0]= 
    "\n1. Nas p\u00e1ginas onde est\u00e3o apresentados os diagramas de fases, controle a composi\u00e7\u00e3o qu\u00edmica e a temperatura da \n    liga clicando e arrastando o"+
    " mouse sobre o diagrama de fases ou digitando valores nas caixas de texto.\n\n"+
    "2. Clique no bot\u00e3o 'travar' para fixar a temperatura ou a composi\u00e7\u00e3o "+
    "qu\u00edmica da liga do sistema selecionado.\n\n"+
    "3. Ao lado direito do diagrama s\u00e3o exibidas duas tabelas e uma janela gr\u00e1fica, cujos conte\u00fados s\u00e3o"+
        " fun\u00e7\u00e3o da posi\u00e7\u00e3o\n   do cursor (ponto preto) sobre o diagrama. A Tabela das Fases e a Janela das"+
         " Microestruturas est\u00e3o sempre\n   presentes, enquanto a Tabela das Microestuturas s\u00f3 \u00e9 apresentada em"+
        " casos not\u00e1veis, como, por exemplo, quando\n   as microestruturas eut\u00e9tica ou eutet\u00f3ide se fazem"+
        " presentes.\n\n";
  if(!hideExplainBeta) polyScreen[3][0] += "4. Clique no bot\u00e3o 'Explica\u00e7\u00e3o', para ver uma breve explica\u00e7\u00e3o sobre o diagrama selecionado.";


  polyScreen[3][1]  = "1. Control the chemical compositin and the temperature by clicking and dragging\n"+
    "    the mouse over the phase diagram or by typing values in the text boxes\n\n"+
    "2. An isotherm or a constant chemical composition is fixed by clicking the\n"+
    "    appropriate Lock button\n\n"+
    "3. The phases' relative chemical composition and the corresponding microstructure\n"+
    "    in the chosen temperature and alloy composition is shown in the right side\n\n" ;      
  if(!hideExplainBeta) polyScreen[3][1] += "4. By clicking in the 'Explain' button, an explanation about the selected diagram\n    is shown";      
  polyScreen[4][0] = "Diagrama de Fases Isomorfo: Sistema Cu-Ni";
  polyScreen[4][1] = "Isomorphous Phase Diagram: Cu-Ni System";
  polyScreen[5][0] = "Diagrama de Fases Eut\u00e9tico: Sistema Pb-Sn";
  polyScreen[5][1]  ="Eutectic Phase Diagram: Pb-Sn System";
  polyScreen[6][0] = "Diagrama de Fases com Ponto Eutet\u00f3ide: Sistema Fe-Fe\u2083C";
  polyScreen[6][1] = "Phase Diagrams with Eutectoid Point; Fe-Fe\u2083C System";
  polyScreen[7][0] = "Composi\u00e7\u00e3o(%pNi)";
  polyScreen[7][1] = "Composition(%wtNi)";
  
  polyScreen[8][0] = "Composi\u00e7\u00e3o(%pSn)"; 
  polyScreen[8][1] = "Composition(%wtSn)";
  
  polyScreen[9][0] = "Composi\u00e7\u00e3o(%pC)";
  polyScreen[9][1] = "Composition(%wtC)";

  polyScreen[10][0] = "Cr\u00e9ditos";
  polyScreen[10][1] = "Credits";
  polyScreen[11][0] = "\t\t                                                           CR\u00c9DITOS" +

    "\n\nDesenvolvimento: Gustavo Estevam Gimenes (Aluno do 2\u00ba ano do Curso de\n" +
    "                             Engenharia de Materiais - N\u00facleo Comum, Escola Polit\u00e9cnica\n"+
    "                             da Universidade de S\u00e3o Paulo, S\u00e3o Paulo - SP, Brasil)"                         + 
    "\n\nOrienta\u00e7\u00e3o: Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia\n" + 
    "                   Metal\u00fargica e de Materiais, Escola Polit\u00e9cnica da Universidade \n"+ 
    "                   de S\u00e3o Paulo, S\u00e3o Paulo - SP, Brasil)" +
    "\n\nTexto: Ivette Frida Cymbaum Oppenheim e Gustavo Estevam Gimenes\n"+
    "\n\nCriado em:                                           \u00daltima atualiza\u00e7\u00e3o: 30/setembro/2011 " + 
    //           " Processing" + 
  "\n\n\nO meio:    'Processing' \u00e9 uma linguagem de programa\u00e7\u00e3o e ambiente de desen-" +  
    "\n              volvimento com foco principal nas artes visuais, aproveitando-se da" +
    "\n              plataforma Java e de uma comunidade virtual intensamente atuante por" + 
    "\n              meio do compartilhamento de c\u00f3digos e bibliotecas atrav\u00e9s da Internet." + 
    "\n\n                Surgiu como iniciativa de Casey Reas e Ben Fry, pesquisadores do" +
    "\n              Instituto de Tecnologia de Massachussets (MIT) dos E.U.A, sendo, des-" +
    "\n              de sua cria\u00e7\u00e3o em 2001, disponibilizado gratuitamente como software" +
    "\n              livre, acess\u00edvel a qualquer interessado a partir do download  no site" + 
    "\n              'processing.org', onde podem ser encontradas informa\u00e7\u00f5es adicionais" +
    "\n              sobre 'Processing'." +    
    "\n\n\nApoio: A simula\u00e7\u00e3o 'Diagramas de Fases' foi desenvolvida no contexto do"+
    "\n           projeto 'Anima\u00e7\u00f5es para disciplinas Introdut\u00f3rias de Ci\u00eancia e"+
    "\n           Engenharia dos Materiais', integrante do 'Programa Ensinar com"+
    "\n           Pesquisa' da Pr\u00f3-Reitoria de Gradua\u00e7\u00e3o da Universidade de S\u00e3o"+
    "\n           Paulo, \u00e0 qual expressamos nossos agradecimentos pela concess\u00e3o"+
    "\n           da bolsa de Inicia\u00e7\u00e3o Cient\u00edfica (Projeto 1887 - ano 2010)."     ; 

  polyScreen[11][1] = "\t\t                                                           CREDITS" +
    "\n\nDevelopment: Gustavo Estevam Gimenes (Second-year student of Materials" +
    "\n                      Engineering - Commom Core, Escola Polit\u00e9cnica"+
    "\n                      da Universidade de S\u00e3o Paulo, S\u00e3o Paulo - SP, Brazil)"                         + 
    "\n\nAdvisor: Ivette F. C. Oppenheim (Departament of Materials and Metallurgical" + 
    "\n              Engineering, Escola Polit\u00e9cnica da Universidade de S\u00e3o Paulo,"+ 
    "\n              S\u00e3o Paulo - SP, Brazil)" +
    "\n\nBuilt with :" + 
    //           " Processing" + 
  "\n\n\nThe media:    'Processing' is an open source programming language and environment" +  
    "\n                     focused on visual arts, enjoying the benefits of the Java platform" +
    "\n                     and of an online community active through the sharing of code and libraries" + 
    "\n\n                      Processing was founded by Ben Fry and Casey Reas, researchers of"+
    "\n                     the Massachussets Institute of Technology (MIT), being available"+ 
    "\n                     since its creation in 2001 as an open-source software, free to"+
    "\n                     dowload in the website 'processing.org', where additional"+
    "\n                     information can be found" + 
    "\n\n\nSupport:    'Anima\u00e7\u00f5es para Disciplinas Introdut\u00f3rias de Ci\u00eancia e Engenharia"  + 
    "\n                 dos Materiais' is part of the 'Programa Ensinar com Pesquisa (PEP)"  +
    "\n                 2010', an initiative of the Pro-Rectorate of Graduate of the"  +
    "\n                 Universidade de S\u00e3o Paulo, to which we express our gratitude for"+
    "\n                 the concession of scholarships ."; 


  polyScreen[12][0] =  "\t\t                                                           CR\u00c9DITOS" +
    "\n\nDesenvolvimento: Gustavo Estevam Gimenes (Aluno do 2\u00ba ano do Curso de\n" +
    "                             Engenharia de Materiais - N\u00facleo Comum, Escola Polit\u00e9cnica\n"+
    "                             da Universidade de S\u00e3o Paulo, S\u00e3o Paulo - SP, Brasil)"                         + 
       "\n\nOrienta\u00e7\u00e3o: Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia\n" + 
    "                   Metal\u00fargica e de Materiais, Escola Polit\u00e9cnica da Universidade \n"+ 
    "                   de S\u00e3o Paulo, S\u00e3o Paulo - SP, Brasil)" +
    "\n\nTexto: Ivette Frida Cymbaum Oppenheim e Gustavo Estevam Gimenes\n"+
    
    "\n\nCriado em:                                           \u00daltima atualiza\u00e7\u00e3o: 30/setembro/2011 " + 
    "\n\n\nApoio: A simula\u00e7\u00e3o 'Diagramas de Fases' foi desenvolvida no contexto do"+
    "\n           projeto 'Anima\u00e7\u00f5es para disciplinas Introdut\u00f3rias de Ci\u00eancia e"+
    "\n           Engenharia dos Materiais', integrante do 'Programa Ensinar com"+
    "\n           Pesquisa' da Pr\u00f3-Reitoria de Gradua\u00e7\u00e3o da Universidade de S\u00e3o"+
    "\n           Paulo, \u00e0 qual expressamos nossos agradecimentos pela concess\u00e3o"+
    "\n           da bolsa de Inicia\u00e7\u00e3o Cient\u00edfica (Projeto 1887 - ano 2010)."+      
     "\n\n                                                       REFER\u00caNCIAS"+
     "\n 'Introdu\u00e7\u00e3o \u00e0 Ci\u00eancia dos Materiais para Engenharia' (EPUSP - PMT2100), Slides\n"+
     "das aulas te\u00f3ricas 5 e 6, ano 2009."+
     "\n\nWilliam D. Callister, Jr., 'Materials science and engineering : an introduction',\n"+
     "7\u00aa Edi\u00e7\u00e3o, editora John Wiley & Sons, 2007 (ISBN: 0-471-73696-1)."+
     "\n\nPhysical-Metallurgy' (MIT 3_40JF09), Notas de aula: aula 21, ano 2009.\n"+
     "ocw.mit.edu/courses/materials-science-and-engineering/3-40j-physical-metallurgy\n"+
     "-fall-2009/lecture-notes/MIT3_40JF09_lec21.pdf - 2010-12-13"+
     "\n\n'ASM handbook v. 9. Metallography and microstructures.' 10\u00aa Edi\u00e7\u00e3o, ASM\n"+
     "International, 1990."      
        
        ; 
  
  polyScreen[12][1] =  "\t\t                                                           CREDITS" +
    "\n\nDevelopment: Gustavo Estevam Gimenes (Second-year student of Materials" +
    "\n                      Engineering - Commom Core, Escola Polit\u00e9cnica"+
    "\n                      da Universidade de S\u00e3o Paulo, S\u00e3o Paulo - SP, Brazil)"                         + 
    "\n\nAdvisor: Ivette F. C. Oppenheim (Departament of Materials and Metallurgical" + 
    "\n              Engineering, Escola Polit\u00e9cnica da Universidade de S\u00e3o Paulo,"+ 
    "\n              S\u00e3o Paulo - SP, Brazil)" +
    "\n\nBuilt with :" + 
    //           " Processing" + 
  "\n\n\nSupport:    'Anima\u00e7\u00f5es para Disciplinas Introdut\u00f3rias de Ci\u00eancia e Engenharia"  + 
    "\n                 dos Materiais' is part of the 'Programa Ensinar com Pesquisa (PEP)"  +
    "\n                 2010', an initiative of the Pro-Rectorate of Graduate of the"  +
    "\n                 Universidade de S\u00e3o Paulo, to which we express our gratitude for"+
    "\n                 the concession of scholarships ."+
      "\n              concess\u00e3o da bolsa de Inicia\u00e7\u00e3o Cient\u00edfica."  +      "\n\n                                                       REFERENCES"+
     "\n\n Henry Marion Howe, 'The Metallography of Steel and Cast Iron', Editora "+
     " McGraw-\n-Hill Book Company, 1916. "+
      "\n\n William D. Callister, Jr., 'Materials science and engineering : an introduction',\n"+
        "7\u00aa Edi\u00e7\u00e3o, editora John Wiley & Sons, 2007 (ISBN: 0-471-73696-1)."; ; 

  polyControl[0][0] = "Temperatura (\u00baC)";
  polyControl[0][1] = "Temperature (\u00baC)";
  polyControl[1][0] = "N\u00edquel-Cobre\n(Isomorfo)";
  polyControl[1][1] = "Nickel-Copper\n(Isomorphous)";
  polyControl[2][0] = "Chumbo-Estanho\n(Eut\u00e9tico)";
  polyControl[2][1] = "Lead-Tin\n(Eutectic)";
  polyControl[3][0] = "Fe-Fe\u2083C\n(Eutet\u00f3ide)";
  polyControl[3][1] = "Fe-Fe\u2083C\n(Eutectoid)";
  polyControl[4][0]="Explica\u00e7\u00e3o";
  polyControl[4][1]="Explanation";
  polyControl[5][0]="Tela Inicial";
  polyControl[5][1]="<<Back";
  polyControl[6][0]="(travar)";
  polyControl[6][1]="(lock)";
  polyControl[7][0]="(destravar)";
  polyControl[7][1]="(unlock)";
  polyControl[8][0]="Ajuda";
  polyControl[8][1]="Help";
  polyControl[9][0]="Ocultar\nExplica\u00e7\u00e3o";
  polyControl[9][1]="Hide\nExplanation";
  polyControl[10][0]="Explica\u00e7\u00e3o";
  polyControl[10][1]="Explanation";
  polyControl[11][0]="Ocultar\nAjuda";
  polyControl[11][1]="Hide\nHelp";
  polyControl[12][0]="Ajuda";
  polyControl[12][1]="Help";
  polyControl[13][0]= "Ocultar\nCr\u00e9ditos";
  polyControl[13][1]= "Hide\nCredits";
  polyControl[14][0]="Cr\u00e9ditos";
  polyControl[14][1]= "Credits";
  polyControl[15][0]="Temperatura\n"; 
  polyControl[15][1]= "Temperature\n"; 
  polyControl[16][0] ="Composi\u00e7\u00e3o\nda Liga";
  polyControl[16][1] ="Composition";


  polyExplain[0][0]="Um diagrama isomorfo (ou de solu\u00e7\u00e3o "+
    "s\u00f3lida) corresponde a uma liga bin\u00e1ria "+
    "cujos componentes s\u00e3o completamente "+
    "sol\u00faveis entre si para todas as "+
    "composi\u00e7\u00f5es. \n\n"+
    "Para estudar o comportamento descrito "+
    "pelo diagrama isomorfo Cu-Ni, vamos "+
    "considerar uma liga com composi\u00e7\u00e3o "+ 
    "35%pNi-65%pCu.\n\n"+
    "Para temperaturas acima de 1261\u00b0C o "+ 
    "sistema apresenta apenas a fase "+
    "l\u00edquida com composi\u00e7\u00e3o 35%pNi-65%pCu. ";


  polyExplain[1][0]="A temperatura de 1261 \u00b0C \u00e9 a temperatura "+
    "liquidus da liga 35%pNi-65%pCu. Acima "+
    "dessa temperatura, a fase l\u00edquida \u00e9 a "+
    "\u00fanica fase est\u00e1vel para o sistema. "+
    "Abaixo dessa temperatura, a fase s\u00f3lida "
    +"sempre existe.";


  polyExplain[2][0]=
    "Para uma temperatura infinitesimalmente "+
    "inferior \u00e0 temperatura liquidus, encontram-se "+
    "em equil\u00edbrio termodin\u00e2mico a fase "+
    "l\u00edquida dominante e os primeiros "+
    "n\u00facleos da fase s\u00f3lida. As composi\u00e7\u00f5es "+
    "aproximadas dessas duas fases podem "+
    "ser inferidas a partir da Regra da "+
    "Alavanca, resultando em "+
    "35%pNi-65%pCu para a fase l\u00edquida e "+
    "46%pNi-54%pCu para a fase s\u00f3lida.";  

  polyExplain[3][0]="A Regra da Alavanca permite determinar, "+
                    "para regi\u00f5es bif\u00e1sicas de diagramas de "+
                    "fases bin\u00e1rios, as composi\u00e7\u00f5es (coluna "+
                    "3 da tabela ao lado) e as quantidades " +
                    "relativas das fases presentes (coluna 2 "+
                    "da tabela ao lado). Para utiliz\u00e1-la, "+
                    "primeiro encontramos a composi\u00e7\u00e3o qu\u00edmica "+
                    "de cada uma das fases, dadas, para a " +
                    "fase l\u00edquida, pelo ponto no qual a isoterma da liga cruza "+
                    "a linha liquidus e, para a fase s\u00f3lida (\u03b1), pelo ponto no qual a "+
                    "isoterma encontra a linha solidus.";


  polyExplain[4][0]="Sendo a composi\u00e7\u00e3o da liga dada por C  "+
    "e sendo P = C  - C   e Q = C  - C  , as "+
    "quantidades relativas das fases, W   e W  , "+
    "pela Regra da Alavanca,ser\u00e3o:\n\n"+
    "W  = \n\n\n"+
    "W  = \n\n ";


  polyExplain[5][0]=
  "A temperatura de 1214\u00b0C \u00e9 a temperatura solidus da liga 35%pNi-65%pCu. "
    +"Imediatamente acima da temperatura "+
    "solidus, a solidifica\u00e7\u00e3o est\u00e1 "+
    "praticamente completa, com a fase s\u00f3lida "+
    "tendo a composi\u00e7\u00e3o aproximada de "+
    "35%pNi-65%pCu, e "+
    "o pouco l\u00edquido restante tendo composi\u00e7\u00e3o "+
    "24%pNi-76%pCu.";

  polyExplain[6][0]=  "Abaixo da temperatura solidus da "+
                    "liga, a fase s\u00f3lida \u00e9 a \u00fanica fase "+
                    "est\u00e1vel para o sistema, tendo "+
                    "composi\u00e7\u00e3o de 35%pNi-65%pCu. A "+
                    "fase s\u00f3lida \u00e9 tamb\u00e9m denominada de "+
                    "fase alfa e geralmente apresenta uma "+
                    "microestrutura policristalina. ";


  //////////////PbSn////////////////////////
  polyExplain[7][0]="Sistemas bin\u00e1rios que apresentam "+
        "solubilidade ilimitada no estado "+
        "l\u00edquido e solubilidade baixa ou "+
        "desprez\u00edvel no estado s\u00f3lido s\u00e3o "+
        "denominados Sistemas Eut\u00e9ticos. "+
        "\u00c9 caracter\u00edstico dos diagramas de "+
        "fases desses sistemas, a presen\u00e7a "+
        "de uma isoterma onde tr\u00eas fases "+
        "de composi\u00e7\u00e3o invariante "+
        "coexistem: uma l\u00edquida e duas "+
        "outras s\u00f3lidas. Essa isoterma, "+
        "conhecida como Patamar Eut\u00e9tico "+
        "(vide figura), define a temperatura "+
        "eut\u00e9tica do sistema. A "+
        "composi\u00e7\u00e3o eut\u00e9tica do sistema "+
        "corresponde \u00e0quela em que o "+
        "sistema se encontra integralmente "+
        "no estado l\u00edquido, numa "+
        "temperatura infinitesimalmente "+
        "superior \u00e0 temperatura eut\u00e9tica "+
        "(vide figura). "+
        "No caso do sistema Pb-Sn, a "+
        "composi\u00e7\u00e3o eut\u00e9tica da liga \u00e9 "+
        "38,1%pPb-61,9%pSn e sua "+
        "temperatura eut\u00e9tica 183\u00baC. ";
        

    
 polyExplain[8][0] = "Para estudar o "+
        "comportamento previsto "+
        "pelo diagrama de fases "+
        "para o sistema eut\u00e9tico "+
        "Pb-Sn, vamos considerar "+
        "diferentes regi\u00f5es de "+
        "composi\u00e7\u00e3o da liga, "+
        "demarcadas pelas "+
        "composi\u00e7\u00f5es, C1 a C5, "+
        "conforme indicadas na "+
        "figura ao lado. "     ;

  polyExplain[9][0]=
                    "A solubilidade s\u00f3lida de Sn em Pb (e vice-versa), "+
                    "\u00e9 muito pequena e, por isso, \u00e9 pequena a faixa "+
                    "de composi\u00e7\u00f5es (C    ) em que uma estrutura "+
                    "s\u00f3lida monof\u00e1sica (ou solu\u00e7\u00e3o s\u00f3lida) pode se "+
                    "formar. Para temperaturas em torno de 50\u00b0C, a "+
                    "solu\u00e7\u00e3o s\u00f3lida da fase \u03b1 (rica em Pb) forma-se "+
                    "para composi\u00e7\u00f5es da liga no intervalo\n"+
                    "0%pSn < C    < C  , onde "+
                    "C  \u224898.5%pPb-1.5%pSn. "+
                    "A solubilidade s\u00f3lida m\u00e1xima de Sn em Pb ocorre na temperatura eut\u00e9tica e \u00e9 de "+
                    "aproximadamente 18,3%pSn.";
                    
 
  
  polyExplain[10][0]=
        "Para C  < C    < C  , quando a temperatura \u00e9 "+
        "inferior \u00e0 temperatura solvus da liga, observa-se "+
        "na microestrutura part\u00edculas de fase "+
        "\u03b2 (rica em Sn) precipitadas na matriz s\u00f3lida de "+
        "fase \u03b1 (rica em Pb).";
  

            polyExplain[22][0] = "Para temperaturas em torno de 50\u00b0C, a "+
        "solu\u00e7\u00e3o s\u00f3lida da fase \u03b2 (rica em Sn) forma-se para\n"+  
        "C  < C     < 100%pSn, onde "+
        "C  \u2248 0.8%pPb- -99.2%pSn. "+
        "A solubilidade "+
        "s\u00f3lida m\u00e1xima de Pb em Sn ocorre na temperatura eut\u00e9tica e \u00e9 de "+
        "aproximadamente 2,2%pPb.";

      

  polyExplain[11][0]=
            "Quando, a partir do estado l\u00edquido, retiramos "+
            "calor da liga de composi\u00e7\u00e3o eut\u00e9tica,\nC     = C  "+
            "= 38,1%pPb-61,9%pSn, sua temperatura diminui "+
            "at\u00e9 que a temperatura eut\u00e9tica seja atingida. "+
            "Nessa temperatura ocorre a transforma\u00e7\u00e3o "+
            "eut\u00e9tica, que \u00e9 a transforma\u00e7\u00e3o da fase l\u00edquida "+
            "(C  = 38,1%pPb-61,9%pSn) nas duas fases "+
            "s\u00f3lidas, a \u03b1 (C  = 81,7%pPb-18,3%pSn) e a \u03b2 (C  "+
            "= 2,2%pPb-97,8%pSn). Quando a fase l\u00edquida "+
            "solidifica integralmente, a temperatura volta a "+
            "diminuir. A microestrutura do s\u00f3lido de "+
            "composi\u00e7\u00e3o eut\u00e9tica, denominada de "+
            "microestrutura eut\u00e9tica, \u00e9 lamelar, ou seja, \u00e9 "+
            "composta de camadas alternadas das fases \u03b1 e \u03b2. ";
            
  polyExplain[13][0]=
        "Para temperaturas imediatamente inferiores \u00e0 temperatura "+
        "eut\u00e9tica e C  < C     < C , a micro- estrutura do "+
        "s\u00f3lido \u00e9 composta de part\u00edculas do s\u00f3lido \u03b1 proeut\u00e9tico, "+
        "imersas em um s\u00f3lido de microestrutura "+
        "eut\u00e9tica.";
        
  //

  polyExplain[12][0]=
        "Quando, a partir do estado l\u00edquido, retiramos "+
        "calor de uma liga de composi\u00e7\u00e3o hipoeut\u00e9tica,\n"+
        "C  < C     < C  , sua temperatura diminui at\u00e9 que a "+
        "temperatura eut\u00e9tica seja atingida. Para "+
        "temperaturas inferiores \u00e0 temperatura liquidus "+
        "coexistem em equil\u00edbrio termodin\u00e2mico a fase "+
        "l\u00edquida e a fase s\u00f3lida \u03b1 (s\u00f3lido \u03b1 pr\u00f3-eut\u00e9tico). "+
        "No patamar eut\u00e9tico (isoterma de temperatura "+
        "eut\u00e9tica), a fase l\u00edquida que ainda resta sofre a "+
        "transforma\u00e7\u00e3o eut\u00e9tica. Quando a fase l\u00edquida "+
        "solidificou integralmente, a temperatura volta a "+
        "diminuir.";
        



        

        
     polyExplain[24][0] = "Para C  < C     < C  , quando a temperatura \u00e9 "+
        "inferior \u00e0 temperatura solvus da liga, observa-se "+
        "na microestrutura part\u00edculas de fase "+
        "\u03b1 (rica em Pb) precipitadas na matriz s\u00f3lida de "+
        "fase \u03b2 (rica em Sn).";
       polyExplain[25][0] = "Para C  < C     < C  , quando a temperatura \u00e9 "+
        "inferior \u00e0 temperatura solvus da liga, observa-se "+
        "na microestrutura part\u00edculas de fase "+
        "\u03b1 (rica em Pb) precipitadas na matriz s\u00f3lida de "+
        "fase \u03b2 (rica em Sn).";
        polyExplain[26][0] = "Quando a partir do estado l\u00edquido, retiramos "+
        "calor de uma liga de composi\u00e7\u00e3o hipereut\u00e9tica,\n"+
        "C  < C     < C , sua temperatura diminui at\u00e9 que a "+
        "temperatura eut\u00e9tica seja atingida. Para "+
        "temperaturas inferiores \u00e0 temperatura liquidus "+
        "coexistem em equil\u00edbrio termodin\u00e2mico a fase "+
        "l\u00edquida e a fase s\u00f3lida \u03b2 (s\u00f3lido \u03b2 pr\u00f3-eut\u00e9tico). "+
        "No patamar eut\u00e9tico (isoterma de temperatura "+
        "eut\u00e9tica), a fase l\u00edquida que ainda resta sofre a "+
        "transforma\u00e7\u00e3o eut\u00e9tica. Quando a fase l\u00edquida "+
        "solidifica integralmente, a temperatura volta a "+
        "diminuir.";


  /////////////////////FE3C///////////////
  
  polyExplain[28][0] = "A isoterma caracterizada pela "+
        "coexist\u00eancia das tr\u00eas fases "+
        "s\u00f3lidas \u03b1, \u03b3 e Fe\u2083C, de "+
        "composi\u00e7\u00f5es invariantes, 0.022%pC, 0.76%pC e 6.7%pC, respectivamente, \u00e9 "+
        "denominada Patamar Eutet\u00f3ide "+
        "(vide figura). Esse patamar "+
        "define a denominada "+
        "Temperatura Eutet\u00f3ide. A Temperatura Eutet\u00f3ide e a "+
        "Composi\u00e7\u00e3o Eutet\u00f3ide, por sua "+
        "vez, definem o Ponto Eutet\u00f3ide (vide "+
        "figura). A "+
        "composi\u00e7\u00e3o eutet\u00f3ide da liga "+
        "corresponde \u00e0quela em que o "+
        "sistema se encontra "+
        "integralmente na fase \u03b3, numa "+
        "temperatura infinitesimalmente "+
        "superior \u00e0 temperatura "+
        "eutet\u00f3ide. No caso "+
        "do sistema Fe-C, a composi\u00e7\u00e3o "+
        "eutet\u00f3ide da liga \u00e9 de 0,76%pC e a "+
        "temperatura eutet\u00f3ide de 727\u00b0C.";
        
              
    polyExplain[29][0] = "Para explorar um pouco o "+
        "comportamento previsto pelo "+
        "diagrama de fases, vamos "+
        "considerar as fases e "+
        "microestruturas formadas "+
        "durante o resfriamento de ligas "+
        "de composi\u00e7\u00f5es C  , C  , C   \ne C  , "+
        "conforme indicadas na figura ao "+
        "lado.";
  
         polyExplain[15][0]=
    "Quando, a partir da fase austenita (\u03b3), retiramos calor de uma liga com a "+
    "composi\u00e7\u00e3o C  eutet\u00f3ide, "+
    "sua temperatura diminui at\u00e9 que a temperatura "+
    "eutet\u00f3ide seja atingida. Ocorre ent\u00e3o a tranforma\u00e7\u00e3o isot\u00e9rmica denominada eutet\u00f3ide,  "+
    "que consiste na transforma\u00e7\u00e3o da fase s\u00f3lida austenita "+
    "(\u03b3) nas duas fases s\u00f3lidas ferrita (\u03b1) e "+
    "cementita (Fe\u2083C). Quando toda a austenita se "+
    "esgota, a temperatura da liga volta a diminuir. A "+
    "microestrutura formada durante a transforma\u00e7\u00e3o eutet\u00f3ide, \u00e9 composta de lamelas "+
    "alternadas de ferrita e cementita e \u00e9 chamada "+
    "de microestrutura eutet\u00f3ide ou perl\u00edtica.";
    
      polyExplain[16][0]=
    "Quando, a partir da fase austenita, retiramos "+
    "calor de um sistema de composi\u00e7\u00e3o C "+
    "hipoeutet\u00f3ide (concentra\u00e7\u00e3o de carbono entre "+
    "0,022%pC e 0,76%pC), sua temperatura "+
    "diminui.";  
    
      polyExplain[17][0]= "Para temperaturas inferiores \u00e0 "+
"temperatura solvus, temos a forma\u00e7\u00e3o da "+
"ferrita proeutet\u00f3ide, que nucleia e cresce nos contornos de "+
"gr\u00e3o da austenita.";
    
    
  polyExplain[18][0]= "Quando a liga atinge a temperatura "+
                      "eutet\u00f3ide, a fase austenita remanescente na "+
                      "liga sofre a transforma\u00e7\u00e3o isot\u00e9rmica eutet\u00f3ide e "+
                      "adquire microestrutura perl\u00edtica. Quando toda a "+
                      "austenita se esgota, a temperatura volta a "+
                      "diminuir. Para temperaturas imediatamente inferiores \u00e0 "+
                      "temperatura eutet\u00f3ide, a microestrutura do "+
                      "s\u00f3lido \u00e9 composta de regi\u00f5es de ferrita proeutet\u00f3ide "+
                      "(que n\u00e3o participa da transforma\u00e7\u00e3o "+
                      "eutet\u00f3ide) imersas em um s\u00f3lido de "+
                      "microestrutura perl\u00edtica.";

 polyExplain[19][0]=
  "A partir da fase austenita, ocorre um processo de resfriamento "+
  "an\u00e1logo ao da liga com composi\u00e7\u00e3o C  para uma "+
  "liga de composi\u00e7\u00e3o C  hipereutet\u00f3ide (concentra\u00e7\u00e3o de "+
  "carbono entre 0.76%pC e 2.1%pC). Quando a "+
  "temperatura da liga se torna inferior \u00e0  "+
    "temperatura solvus, cementita proeutet\u00f3ide "+
    "nucleia e cresce nos contornos de "+
    "gr\u00e3o da austenita. "+
    "Quando o sistema atinge a temperatura "+
    "eutet\u00f3ide, a fase austenita remanescente "+
    "sofre a transforma\u00e7\u00e3o eutet\u00f3ide e "+
    "adquire microestrutura perl\u00edtica. "+
    "Para temperaturas imediatamente inferiores \u00e0 "+
    "temperatura eutet\u00f3ide, a microestrutura do "+
    "s\u00f3lido \u00e9 composta de regi\u00f5es de cementita proeutet\u00f3ide "+
    "(que n\u00e3o participam da transforma\u00e7\u00e3o "+
    "eutet\u00f3ide) imersas em um s\u00f3lido de "+
    "microestrutura perl\u00edtica.";

  polyExplain[20][0]="O sistema tamb\u00e9m possui um ponto "+
    "eut\u00e9tico \u00e0 temperatura de 1147 \u00b0C e "+
    "composi\u00e7\u00e3o de 95.7%pFe-4.3%pC. Quando, a partir do estado l\u00edquido, retiramos calor de uma liga com a composi\u00e7\u00e3o eut\u00e9tica, sua temperatura diminui "+
    "at\u00e9 que a temperatura eut\u00e9tica seja atingida. Nessa "+
    "temperatura ocorre a transforma\u00e7\u00e3o "+
    "eut\u00e9tica, que consiste na transforma\u00e7\u00e3o da fase l\u00edquida em duas fases "+
    "s\u00f3lidas, a austenita (com composi\u00e7\u00e3o 97.9%pFe-2.1%pC) e a cementita (com composi\u00e7\u00e3o 93.3%pFe-6.7%pC). "+ 
    "A microestrutura do s\u00f3lido de composi\u00e7\u00e3o eut\u00e9tica, que consiste em  part\u00edculas de cementita dispersas numa matriz austen\u00edtica, \u00e9 denominada ledeburita-I."; 

  polyExplain[21][0]="Com o resfriamento da liga com a estrutura da ledeburita-I para a temperatura eutet\u00f3ide de 727\u00b0C, "+
                      "a austenita presente no sistema sofre a transforma\u00e7\u00e3o eutet\u00f3ide, dando "+
                      "origem a ferrita alfa e cementita num "+
                      "arranjo perl\u00edtico, formando a microestrutura "+
                      "da ledeburita-II.";

        //
  polyTable[0][0]="Fase";
  polyTable[0][1]="Phase";
  polyTable[1][0]="Fra\u00e7\u00e3o\n(%p)";
  polyTable[1][1]="Fraction\n(%wt)";
  polyTable[2][0]="Composi\u00e7\u00e3o\n(%p)";
  polyTable[2][1]="Composition\n(%wt)";
  polyTable[3][0]="L\u00edquido";
  polyTable[3][1] ="Liquid";
  polyTable[4][0]="S\u00f3lido-\nAlfa";
  polyTable[4][1]="Solid-\nAlpha";
  polyTable[5][0]="%p";        
  polyTable[5][1]="%wt";
  polyTable[6][0]="S\u00f3lido-\nBeta";
  polyTable[6][1]="Solid-\nBeta";
  polyTable[7][0]="Austenita";
  polyTable[7][1]="Austenite";
  polyTable[8][0]="Ferrita\nDelta";
  polyTable[8][1]="Delta\nFerrite";
  polyTable[9][0]="Cementita";
  polyTable[9][1]="Cementite";
}     

public void tabela(float x, float y) {
  stroke(0);
  line(x, y, x+180,y);
  line(x, y+90, x+180,y+90);
  line(x+180, y, x+180,y+90);
  line(x, y, x,y+90);
  stroke(0);
  line(x, y+26, x+180,y+26);
  line(x, y+58, x+180,y+58);
  line(x+56, y, x+56,y+90);
  line(x+103, y, x+103,y+90);
  stroke(0);
  textAlign(CENTER);
  textFont(fontText,12);
  textLeading(12);
  fill(200, 60, 60);
  text(polyTable[0][lang], x+28, y+18);
  fill(0);
  text(polyTable[1][lang], x+80, y+11); //TANTANTAN MUDAR AQUI
  text(polyTable[2][lang], x+142, y+11);
  rectMode(CENTER);

  if(tipo==1) {
    textAlign(CENTER);
    if(fase=="L\u00cdQUIDO") {
      fill(240);
      rect(x+28, y+42, 56,32);
      fill(0);
      text(polyTable[3][lang], x+28, y+47);
      text("100", x+80, y+47);
      text(nf(100-composicao,2,1)+" Cu\n"+nf(composicao,2,1) +" Ni\n", x+141.5f, y+41);
      text("---", x+28, y+78);
      text("---", x+80, y+78);  
      text("---", x+141.5f, y+78);
    } else    if(fase=="L\u00cdQUIDO+ALFA") {
      fill(240);
      rect(x+28, y+42, 56,32);

      fill(ALFA);
      rect(x+28, y+74, 56,32);
      fill(0);

      text(polyTable[3][lang], x+28, y+47);

      text(polyTable[4][lang], x+28, y+73);

      text(nf((1-W2)*100,2, 1), x+80, y+47);
      text(nf((W2)*100,2, 1), x+80, y+78);  

      text(nf(((linha1-xinicio)*100/(xfim-xinicio)),2,1) +" Ni\n"+nf((100-((linha1-xinicio)*100/(xfim-xinicio))),2,1)  +" Cu\n", x+142, y+41);
      text(nf(((linha2-xinicio)*100/(xfim-xinicio)),2,1) +" Ni\n"+nf((100-((linha2-xinicio)*100/(xfim-xinicio))),2,1)  +" Cu\n", x+142, y+73);
    }else     if(fase=="ALFA") { 
      fill(ALFA);
      rect(x+28, y+42, 56,32);
      fill(0);
      text(polyTable[4][lang], x+28, y+41);
      text("100", x+80, y+47);
      text(nf(100-composicao,2,1) +" Cu\n"+nf(composicao,2,1)  +" Ni\n", x+142, y+41);
      text("---", x+28, y+78);
      text("---", x+80, y+78);  
      text("---", x+141.5f, y+78);
    }else     if (fase=="TRANSI\u00c7\u00c3O\nDE FASES") {
      text("---", x+28, y+45);
      text("---", x+28, y+78);
      text("---", x+80, y+45);
      text("---", x+80, y+78);  
      text("---", x+142, y+45);
      text("---", x+142, y+78);
    }
  }

  ///////////////////Pb-Sn//////////////////
  else if(tipo==2) { 
    textAlign(CENTER);   
    if(fase=="L\u00cdQUIDO") {
      fill(240);
      rect(x+28, y+42, 56,32);
      fill(0);
      text(polyTable[3][lang], x+28, y+47);
      text("100", x+80, y+47);
      text(nf(100-composicao,2,1) +" Pb\n"+nf(composicao,2,1)  +" Sn\n", x+142, y+41);
      textAlign(CENTER);
      text("---", x+28, y+78);
      text("---", x+80, y+78);  
      text("---", x+141.5f, y+78);
    } else     if (fase=="TRANSI\u00c7\u00c3O\nDE FASES") {
      text("---", x+28, y+45);
      text("---", x+28, y+78);
      text("---", x+80, y+45);
      text("---", x+80, y+78);  
      text("---", x+142, y+45);
      text("---", x+142, y+78);
    }else     if(fase=="ALFA") { 
      fill(ALFA);
      rect(x+28, y+42, 56,32);
      fill(0);
      text(polyTable[4][lang], x+28, y+42);
      text("100", x+80, y+47);
      text(nf(100-composicao,2,1) +" Pb\n"+nf(composicao,2,1)  +" Sn\n", x+142, y+41);
      text("---", x+28, y+78);
      text("---", x+80, y+78);  
      text("---", x+141.5f, y+78);
    }else    if(fase=="BETA") { 
      fill(BETA);
      rect(x+28, y+42, 56,32);
      fill(0);
      text(polyTable[6][lang], x+28, y+41);
      text("100", x+80, y+47);
      text(nf(100-composicao,2,1) +" Pb\n"+nf(composicao,2,1)  +" Sn\n", x+142, y+41);
      text("---", x+28, y+78);
      text("---", x+80, y+78);  
      text("---", x+141.5f, y+78);
    }else     if(fase=="L\u00cdQUIDO+ALFA") { 
      fill(240);
      rect(x+28, y+42, 56,32);
      fill(ALFA);
      rect(x+28, y+74, 56,32);
      fill(0);
      text(polyTable[3][lang], x+28, y+47);
      text(polyTable[4][lang], x+28, y+73);
      text(nf((W2)*100,2, 1), x+80, y+47);
      text(nf((1-W2)*100,2, 1), x+80, y+78);  
      text(nf(100-((linha1-xinicio)*100/(xfim-xinicio)),2,1) +" Pb\n"+nf((((linha1-xinicio)*100/(xfim-xinicio))),2,1)  +" Sn\n", x+142, y+73);
      text(nf(100-((linha2-xinicio)*100/(xfim-xinicio)),2,1) +" Pb\n"+nf((((linha2-xinicio)*100/(xfim-xinicio))),2,1)  +" Sn\n", x+142, y+41);
    }else if(fase=="L\u00cdQUIDO+BETA") {
      fill(240);
      rect(x+28, y+42, 56,32);
      fill(0);
      fill(BETA);
      rect(x+28, y+74, 56,32);
      fill(0);
      text(polyTable[3][lang], x+28, y+47);
      text(polyTable[6][lang], x+28, y+73);
      text(nf((1-W2)*100,2, 1), x+80, y+47);
      text(nf((W2)*100,2, 1), x+80, y+78);  
      text(nf((100-(linha1-xinicio)*100/(xfim-xinicio)),2,1) +" Pb\n"+nf((((linha1-xinicio)*100/(xfim-xinicio))),2,1)  +" Sn\n", x+142, y+41);
      text(nf((100-(linha2-xinicio)*100/(xfim-xinicio)),2,1) +" Pb\n"+nf((((linha2-xinicio)*100/(xfim-xinicio))),2,1)  +" Sn\n", x+142, y+73);
    }else if(fase=="ALFA+BETA") {  
      fill(ALFA);
      rect(x+28, y+42, 56,32);
      fill(BETA);
      rect(x+28, y+74, 56,32);
      fill(0);
      text(polyTable[4][lang], x+28, y+41);
      text(polyTable[6][lang], x+28, y+73);
      
      

      text(nf(100-((linha1-xinicio)*100/(xfim-xinicio)),2,1) +" Pb\n"+nf((((linha1-xinicio)*100/(xfim-xinicio))),2,1)  +" Sn\n", x+142, y+41);
      text(nf(100-((linha2-xinicio)*100/(xfim-xinicio)),2,1) +" Pb\n"+nf((((linha2-xinicio)*100/(xfim-xinicio))),2,1)  +" Sn\n", x+142, y+73);

      //tabela de microestrutura 
      fill(200, 60, 60);
      text("Microestrutura",  x+53, y+112);
      fill(0);
      text("Fra\u00e7\u00e3o (%p)",  x+140, y+112);

      if((xcursor>=181)&&(xcursor<=661)) {
        
      text(nf((W2)*100,2, 1), x+80, y+47);
      text(nf((1-W2)*100,2, 1), x+80, y+78);     
        
        
        line(x, y+95, x+180,y+95);
        line(x, y+190, x+180,y+190);
        line(x+180, y+95, x+180,y+190);
        line(x, y+95, x,y+190);

        line(x, y+118, x+180,y+118);
        line(x, y+142, x+180,y+142); 
        line(x, y+166, x+180,y+166); 
        line(x+100, y+95, x+100,y+190);

        // image(icon[3], 715,509,99, 23);
        // fill(255);

        fill(0);


        if(xcursor<446.2f) { 

          text("Eut\u00e9tica",  x+53, y+136);
          text( nf( (xcursor-181)*100 /(446.2f-181),2,1), x+140, y+136);
          text("Alfa\nPr\u00f3-eut\u00e9tica",  x+53, y+153);
          text(  nf((446.2f-xcursor) /(446.2f-181)*100,2,1), x+140, y+160);

          text("Alfa\nEut\u00e9tica",  x+53, y+177); 
          text(  nf((100*(W2 -(446.2f-xcursor) /(446.2f-181)) ),2,1), x+140, y+184);
        }
        else {

          text("Eut\u00e9tica",  x+53, y+136);
          text(  nf((666-xcursor) /(666-446.2f)*100,2,1), x+140, y+136);
          text("Beta\nPr\u00f3-eut\u00e9tica",  x+53, y+153);
          text( nf( (xcursor-446.2f) /(666-446.2f)*100,2,1), x+140, y+160);
          text("Beta\nEut\u00e9tica",  x+53, y+177); 
          text( nf( ( 1-W2 - (xcursor-446.2f) /(666-446.2f) )*100, 2,1), x+140, y+184);
        }
      }else {
                
      text(nf((1-W2)*100,2, 1), x+80, y+47);
      text(nf((W2)*100,2, 1), x+80, y+78);     
      
        line(x, y+95, x+180,y+95);
        line(x+180, y+95, x+180,y+166);
        line(x, y+95, x,y+166);

        line(x, y+118, x+180,y+118);
        line(x, y+142, x+180,y+142); 
        line(x, y+166, x+180,y+166); 
        line(x+100, y+95, x+100,y+166);

        if(xcursor<181) {
          
          text("Alfa",  x+53, y+135);
          text( nf((1-W2)*100,2,1), x+140, y+135);
          text("Beta\nPrecipitado",  x+53, y+153);
          text( nf((W2)*100,2,1), x+140, y+159);
        }
        if(xcursor>661) {
          text("Beta",  x+53, y+135);
          text( nf((W2)*100,2,1), x+140, y+135);
          text("Alfa\nPrecipitado",  x+53, y+153);
          text( nf((1-W2)*100,2,1), x+140, y+159);
        }
      }
    }
  }
  ////////////////FE3C////////////////
  else if(tipo==3) {   
    textAlign(CENTER);  
    if(fase=="FERRITA (ALFA)") {
      fill(ALFA);
      rect(x+28, y+42, 56,32);
      fill(0);
      text("Ferrita\nAlfa", x+28, y+41);
      text("100", x+80, y+45);
      text(nf(100-composicao,2,2) +" Fe\n"+nf(composicao,1,2)  +" C\n", x+142, y+41);
      text("---", x+28, y+78);
      text("---", x+80, y+78);  
      text("---", x+141.5f, y+78);
    }else    if(fase=="AUSTENITA") {
      fill(GAMA);
      rect(x+28, y+42, 56,32);
      fill(0);
      text(polyTable[7][lang], x+28, y+47);
      text("100", x+80, y+47);
      text(nf(100-composicao,2,2) +" Fe\n"+nf(composicao,1,2)  +" C\n", x+142, y+41);
      text("---", x+28, y+78);
      text("---", x+80, y+78);  
      text("---", x+141.5f, y+78);
    }else    if(fase=="FERRITA (DELTA)") {
      fill(DELTA);
      rect(x+28, y+42, 56,32);
      fill(0);
      text(polyTable[8][lang], x+28, y+41);
      text("100", x+80, y+47);
      text(nf(100-composicao,2,2) +" Fe\n"+nf(composicao,1,2)  +" C\n", x+142, y+41);
      text("---", x+28, y+78);
      text("---", x+80, y+78);  
      text("---", x+141.5f, y+78);
      
   }else    if(fase=="AUSTENITA+CEMENTITA") {
      fill(GAMA);
      rect(x+28, y+42, 56,32);
      fill(FE3C);
      rect(x+28, y+74, 56,32);
      fill(0);
      
      text(polyTable[7][lang], x+28, y+47);
      text(polyTable[9][lang], x+28, y+78);
      
      
      text(nf((100-((linha1-xinicio)*6.7f/(xfim-xinicio))),2,2) +" Fe\n"+nf(((linha1-xinicio)*6.7f/(xfim-xinicio)),1,2)  +" C\n", x+142, y+41);
      text("93.3" +" Fe\n"+"6.70" +" C\n", x+142, y+73);

      //tabela de microestrutura 
      if((xcursor>=262)&&(xcursor<461)) {
        
         text(nf((1-(xcursor - 262)/(678-262))*100,2, 1), x+80, y+47);;
         text(nf(((xcursor - 262)/(678-262))*100,2, 1), x+80, y+78);  
        
        fill(200, 60, 60);
        text("Microestrutura",  x+53, y+111);
        fill(0);
        text("Fra\u00e7\u00e3o(%p)",  x+140, y+113);

        line(x, y+95, x+180,y+95);
        line(x, y+190, x+180,y+190);
        line(x+180, y+95, x+180,y+190);
        line(x, y+95, x,y+190);

        line(x, y+118, x+180,y+118);
        line(x, y+142, x+180,y+142); 
        line(x, y+166, x+180,y+166); 
        line(x+100, y+95, x+100,y+190);

        // image(icon[4], 715,509,99, 23); 
        fill(0);
        text("Ledeburita-I",  x+53, y+160);
        fill(0);
        text("Austenita\nPr\u00f3-eut\u00e9tica",  x+53, y+129);
        text("Austenita\nLedeb\u00farica",  x+53, y+177); 
        text( nf((((xcursor - 262)/(461-262))*100),2,1), x+140, y+160); 
        text( nf(((1-(xcursor-262 )/(461-262))*100),2,1), x+140, y+136); 
        text( nf((1-(xcursor - 262)/(678-262)-(1-(xcursor-262)/(461-262)))*100,2,1), x+140, y+184);
      
    
  }else if(xcursor>=461) {
        
         text(nf((1-(xcursor - 262)/(678-262))*100,2, 1), x+80, y+47);;
         text(nf(((xcursor - 262)/(678-262))*100,2, 1), x+80, y+78);  
        
        fill(200, 60, 60);
        text("Microestrutura",  x+53, y+111);
        fill(0);
        text("Fra\u00e7\u00e3o(%p)",  x+140, y+113);

        line(x, y+95, x+180,y+95);
        line(x, y+190, x+180,y+190);
        line(x+180, y+95, x+180,y+190);
        line(x, y+95, x,y+190);

        line(x, y+118, x+180,y+118);
        line(x, y+142, x+180,y+142); 
        line(x, y+166, x+180,y+166); 
        line(x+100, y+95, x+100,y+190); 
        //   image(icon[4], 715,533,99, 23); 
        fill(0);
        text("Ledeburita-I",  x+53, y+160);
        text("Cementita\nPr\u00f3-eut\u00e9tica",  x+53, y+129);
        text("Cementita\nLedeb\u00farica",  x+53, y+177); 
        text( nf(((1-(xcursor - 461)/(678-461))*100),2,1), x+140, y+160); 
        text( nf((((xcursor - 461)/(678-461))*100),2,1), x+140, y+136); 
        text( nf(           (((xcursor - 262)/(678-262))-(xcursor - 461)/(678-461))*100,2,1), x+140, y+184);
        
        
        
      }else {
        text(nf((1-W2)*100,2, 1), x+80, y+47);
      text(nf((W2)*100,2, 1), x+80, y+78); 
      }
      
    }  else    if(fase=="PERLITA") {      
      
      fill(ALFA);
      rect(x+28, y+42, 56,32);
      fill(FE3C);
      rect(x+28, y+74, 56,32);
      fill(0);
      text("Ferrita\nAlfa", x+28, y+41);
      text(polyTable[9][lang], x+28, y+78);
      text(nf((1-(xcursor-linha1)/(linha2-linha1))*100,2, 1), x+80, y+45);
      text(nf(((xcursor-linha1)/(linha2-linha1))*100,2, 1), x+80, y+78);  
      text(nf((100-(linha1-xinicio)*6.7f/(xfim-xinicio)),2,2) +" Fe\n"+nf((((linha1-xinicio)*6.7f/(xfim-xinicio))),1,2)  +" C\n", x+142, y+41);
      text(nf((100-(linha2-xinicio)*6.7f/(xfim-xinicio)),2,2) +" Fe\n"+nf((((linha2-xinicio)*6.7f/(xfim-xinicio))),1,2)  +" C\n", x+142, y+73);

      //tabela de microestrutura 
      fill(200, 60, 60);
      text("Microestrutura",  x+53, y+111);
      fill(0);
      text("Fra\u00e7\u00e3o(%p)",  x+140, y+113);

      line(x, y+95, x+180,y+95);
      line(x, y+190, x+180,y+190);
      line(x+180, y+95, x+180,y+190);
      line(x, y+95, x,y+190);

      line(x, y+118, x+180,y+118);
      line(x, y+142, x+180,y+142); 
      line(x, y+166, x+180,y+166); 
      line(x+100, y+95, x+100,y+190); 

      if(xcursor<140) {
        //   image(icon[6], 715,509,99, 23); 
        //fill(255);
        text("Perlita",  x+53, y+135);
        fill(0);
        text("Ferrita\nPr\u00f3-eutet\u00f3ide",  x+53, y+153);
        text("Ferrita\nPerlitica",  x+53, y+177); 
        text( nf(((xcursor-72)/(140-72))*100,2,1), x+140, y+136);
        text( nf((1-(xcursor-72)/(140-72))*100,2,1), x+140, y+160);
        text( nf(((xcursor-72)/(140-72)-((xcursor-linha1)/(linha2-linha1)))*100 ,2,1), x+140, y+184);
    
  
  }
      
      if((xcursor<262)&&(xcursor>=140)) {
        // image(icon[6], 715,509,99, 23); 
        //   fill(255);
        text("Perlita",  x+53, y+135);
        fill(0);
        text("Cementita\nPr\u00f3-eutet\u00f3ide",  x+53, y+153);
        text("Cementita\nPerlitica",  x+53, y+177); 
        text( nf(((678-xcursor)/(678-140)*100),2,1), x+140, y+136); 
        text( nf(((xcursor-140)/(678-140)*100),2,1), x+140, y+160); 
        text( nf((((678-xcursor)/(678-140)-(1-(xcursor-linha1)/(linha2-linha1)))*100),2,1), x+140, y+184);
      }

      if((xcursor>=262)&&(xcursor<461)) {
        //image(icon[6], 715,509,99, 23); 
        // fill(255);
        text("Cementita\nPr\u00f3-eut\u00e9toide",  x+53, y+129);
        // image(icon[5], 715,533,99, 23); 
        text("Arranjo Perl\u00edtico",  x+53, y+160);
        fill(0);
        text( nf(((xcursor-140)/(678-140)*100),2,1), x+140, y+136); 
        text( nf(((1-(xcursor-140)/(678-140))*100),2,1), x+140, y+160); 
       fill(255);
       noStroke();
       rect(800, 574, 200, 34);
           }
      if(xcursor>=461) {
        text("Cementita\nPr\u00f3-eut\u00e9toide",  x+53, y+129);
        //image(icon[5], 715,533,99, 23); 
        // fill(255);
        text("Ledeburita-II",  x+53, y+160);
        fill(0);
        text("Cementita\nLedeb\u00farica",  x+53, y+177);

        text( nf(((xcursor - 461)/(678-461)*100),2,1), x+140, y+136); 
        text( nf(((1-(xcursor - 461)/(678-461))*100),2,1), x+140, y+160); 
        text( nf(((1-(xcursor - 461)/(678-461) -1+(xcursor-linha1)/(linha2-linha1))*100),2,1), x+140, y+184);

        /*text("Cementita",  x+53, y+135);
         text("Ledeburita",  x+53, y+160);
         text( nf(((xcursor - 461)/(678-461)*100),2,1), x+140, y+136); 
         text( nf(((1-(xcursor - 461)/(678-461))*100),2,1), x+140, y+160); 
         text("Cementita\nPr\u00f3-eut\u00e9tica",  x+53, y+177);
         text( nf(((xcursor - 461)/(678-461)*100*0.12),2,1), x+140, y+184);*/
      }
    }   else    if (fase=="TRANSI\u00c7\u00c3O\nDE FASES") {
      text("---", x+28, y+45);
      text("---", x+28, y+78);
      text("---", x+80, y+45);
      text("---", x+80, y+78);  
      text("---", x+142, y+45);
      text("---", x+142, y+78);
    }else    if(fase=="L\u00cdQUIDO+CEMENTITA") {
      fill(240);
      rect(x+28, y+42, 56,32);
      fill(FE3C);
      rect(x+28, y+74, 56,32);
      fill(0);
      text(polyTable[3][lang], x+28, y+47);
      text(polyTable[9][lang], x+28, y+79);
      text(nf((1-W2)*100,2, 1), x+80, y+47);
      text(nf((W2)*100,2, 1), x+80, y+79);  
      text(nf(100-((linha1-xinicio)*6.7f/(xfim-xinicio)),2,2) +" Fe\n"+nf((((linha1-xinicio)*6.7f/(xfim-xinicio))),1,2)  +" C\n", x+142, y+41);
      text("93.30" +" Fe\n"+"6.70" +" C\n", x+142, y+74);
    }else   if(fase=="L\u00cdQUIDO+AUSTENITA") {
      fill(240);
      rect(x+28, y+42, 56,32);
      fill(GAMA);
      rect(x+28, y+74, 56,32);
      fill(0);
      text(polyTable[3][lang], x+28, y+47);
      text(polyTable[7][lang], x+28, y+79);
      text(nf((W2)*100,2, 1), x+80, y+47);
      text(nf((1-W2)*100,2, 1), x+80, y+79);  
      text(nf((100-(linha1-xinicio)*6.7f/(xfim-xinicio)),2,2) +" Fe\n"+nf((((linha1-xinicio)*6.7f/(xfim-xinicio))),1,2)  +" C\n", x+142, y+73);
      text(nf((100-(linha2-xinicio)*6.7f/(xfim-xinicio)),2,2) +" Fe\n"+nf((((linha2-xinicio)*6.7f/(xfim-xinicio))),1,2)  +" C\n", x+142, y+41);
    
  
  }else   if(fase=="L\u00cdQUIDO+FERRITA (DELTA)") {
      fill(240);
      rect(x+28, y+42, 56,32);
      fill(DELTA);
      rect(x+28, y+74, 56,32);
      fill(0);
      text(polyTable[3][lang], x+28, y+47);
      text(polyTable[8][lang], x+28, y+73);
      text(nf((W2)*100,2, 1), x+80, y+47);
      text(nf((1-W2)*100,2, 1), x+80, y+79);  
      text(nf((100-(linha1-xinicio)*6.7f/(xfim-xinicio)),2,2) +" Fe\n"+nf((((linha1-xinicio)*6.7f/(xfim-xinicio))),1,2)  +" C\n", x+142, y+73);
      text(nf((100-(linha2-xinicio)*6.7f/(xfim-xinicio)),2,2) +" Fe\n"+nf((((linha2-xinicio)*6.7f/(xfim-xinicio))),1,2)  +" C\n", x+142, y+41);
    }else    if(fase=="FERRITA (ALFA)+AUSTENITA") {
      fill(ALFA);
      rect(x+28, y+42, 56,32);
      fill(GAMA);
      rect(x+28, y+74, 56,32);
      fill(0);
      text("Ferrita\nAlfa", x+28, y+41);
      text(polyTable[7][lang], x+28, y+79);
      text(nf((1-W2)*100,2, 1), x+80, y+47);
      text(nf((W2)*100,2, 1), x+80, y+79);  

      text(nf((100-(linha1-xinicio)*6.7f/(xfim-xinicio)),2,2) +" Fe\n"+nf((((linha1-xinicio)*6.7f/(xfim-xinicio))),1,2)  +" C\n", x+142, y+41);
      text(nf((100-(linha2-xinicio)*6.7f/(xfim-xinicio)),2,2) +" Fe\n"+nf((((linha2-xinicio)*6.7f/(xfim-xinicio))),1,2)  +" C\n", x+142, y+73);
    }    else   if(fase=="L\u00cdQUIDO") {
      fill(240);
      rect(x+28, y+42, 56,32);
      fill(0);  
      text(polyTable[3][lang], x+28, y+47);
      text("100", x+80, y+47);
      text(nf(100-composicao,2,2) +" Fe\n"+nf(composicao,1,2)  +" C\n", x+142, y+41);
      text("---", x+28, y+78);
      text("---", x+80, y+78);  
      text("---", x+141.5f, y+78);
    }else    if(fase== "FERRITA (DELTA)+AUSTENITA") {
      fill(DELTA);
      rect(x+28, y+42, 56,32);
      fill(GAMA);
      rect(x+28, y+74, 56,32);
      fill(0);
      text(polyTable[8][lang], x+28, y+41);
      text(polyTable[7][lang], x+28, y+77);
      text(nf((1-W2)*100,2, 1), x+80, y+47);
      text(nf((W2)*100,2, 1), x+80, y+77);  
      text(nf((100-(linha1-xinicio)*6.7f/(xfim-xinicio)),2,2) +" Fe\n"+nf((((linha1-xinicio)*6.7f/(xfim-xinicio))),1,2)  +" C\n", x+142, y+41);
      text(nf((100-(linha2-xinicio)*6.7f/(xfim-xinicio)),2,2) +" Fe\n"+nf((((linha2-xinicio)*6.7f/(xfim-xinicio))),1,2)+" C\n", x+142, y+73);
    }
  }
  rectMode(CORNER);
}

public void div(String dividend, String divisor, float x, float y){
  textAlign(CENTER);   
  text(dividend, x,y);
  int s = (dividend.length()>divisor.length()) ? dividend.length() : divisor.length();
  stroke(0);
  line(x-10*s,y+3, x+10*s, y+3);
  text(divisor, x, y+20);
  textAlign(LEFT);
} 

public void sub(String s, PFont font, int TextSize, float x, float y){ //given char's coordinates and the original fontSize, prints a smaller character 
     pushStyle();
     textFont(font, TextSize/1.5f);
     text(s, x, y);
     textFont(font, TextSize);
     popStyle();
}

public void variable(String var, String explicacao, float x, float y, int f, float boxPosx, float boxPosy, float boxWidth, float boxHeight) { 
  //dado uma f\u00f3rmula guardada num array var e a explica\u00e7\u00e3o bonitinha
  //guardada no explicacao, vai escrever na tela a f\u00f3rmula e, quando o mouse estiver sobre algum termo, sua defini\u00e7\u00e3o ser\u00e1 exibida 
  //os dois vetores devem ter o mesmo tamanho. f \u00e9 o tamanho da fonte. vai desenhar um vetor em cima da letra caso ela seja precedida por *; faz subscrito de seguida por _
  pushStyle();
  textSize(f);
  textLeading(f);

textAlign(CENTER);
  stroke(0);
    fill(100, 100, 200);
   text(var, x, y);
    textAlign(LEFT);  
fill(0);
  if((mouseX>(x-f*var.length()/4))&&(mouseX<(x+f*var.length()/4))&&(mouseY>(y-f))&&(mouseY<(y))) {
    explicacao(boxPosx, boxPosy, explicacao, boxWidth, boxHeight, f);
    loop();
  }

  popStyle();
}

public void explicacao(float xpos, float ypos, String explain, float vwidth, float vheight, int f) { //will create a pop-up to explain some variable; xpos and ypos are the position of the variable; 
  loop();
  boolean toggleText = true;
  pushStyle();
  //first, this smooth transition, using millis 
  stroke(0);
  fill(150);
  rectMode(CORNER);
  noStroke();
  fill(240);
  if(vwidth!=0)   rect(xpos,ypos,vwidth,vheight);
  textSize(f);
  textAlign(LEFT);
  fill(0);
  textLeading(f);
  text(explain, xpos+f/6, ypos, vwidth, vheight);
  popStyle();
}
class Textbox { // 1-line simple textbox. ENTER will issue the typed data to the program and take out the focus
  PImage trickery; // background image to hide old text
  PGraphics textbox, border;

  int Border;
  int TWidth, THeight;
  int x, y;

  boolean OnFocus;

  String typed, cursorbuffer;    // text buffers
  int CursorCharIndex;
  int Fontsize;
  int TColour;
  float Margin; // in percentage (safer)
 
  Textbox(int _x, int _y, int _TWidth, int _THeight, String _defaulttext, int _Border, float _Margin, int _TColour) {
    x = _x; 
    y = _y; 
    TWidth = _TWidth; 
    THeight = _THeight;
    typed = cursorbuffer = _defaulttext;

    Border = _Border;

    textbox = createGraphics(TWidth - 2*Border, THeight - 2*Border, P2D);  // textbox area
    trickery = createImage(TWidth, THeight, RGB);    // background image

    border = createGraphics(TWidth, THeight, P2D);   // border
    OnFocus = false;
    CursorCharIndex = typed.length();
    CalculateFont();
    textbox.imageMode(CENTER);
    border.imageMode(CENTER);
    TColour = _TColour;
    Margin = _Margin;
    
  }

  public void CalculateFont() {
    Fontsize = THeight - 2*Border;
  }

  public void buildtrickery() {
    int i, px, py;
    int TMPColour, GETColour;

    trickery.loadPixels();
    for (i = 0; i < trickery.pixels.length; i++) {
      px = i%TWidth;
      py = i/TWidth;
      GETColour = get(x -PApplet.parseInt(TWidth/2) + (i % TWidth), y -PApplet.parseInt(THeight/2) + (i/TWidth));

      if ( (py < Border && py < px) || (px >= TWidth - Border && py <= px - (TWidth - THeight)) ) {
        TMPColour = lerpColor(color(0), GETColour, 0.8f);
      }
      else if (( py >= THeight - Border ) || ( px < Border )) {
        TMPColour = lerpColor(color(255), GETColour, 0.8f);
      }
      else TMPColour = GETColour;

      trickery.pixels[i] = TMPColour;
    }
    trickery.updatePixels();
  }

  public void KeyControl() {
    if (key == BACKSPACE && CursorCharIndex > 0) {
      typed = typed.substring(0, CursorCharIndex-1) + typed.substring(CursorCharIndex, typed.length());
      //cursorbuffer = typed.substring(0, CursorCharIndex-1);
      CursorCharIndex--;
      //cursorbuffer = typed.substring(0, CursorCharIndex);
    }
    else if (key == DELETE && CursorCharIndex < typed.length()) {
      typed = typed.substring(0, CursorCharIndex) + typed.substring(CursorCharIndex+1, typed.length());
      //cursorbuffer = typed.substring(0, CursorCharIndex);
    }
    else if (key != CODED && (key != ENTER && key != RETURN) && key != DELETE && key != BACKSPACE) {
      typed = typed.substring(0, CursorCharIndex) + key + typed.substring(CursorCharIndex, typed.length());
      CursorCharIndex++;
      //cursorbuffer = typed.substring(0, CursorCharIndex);
    }
    if (key == ENTER || key == RETURN) OnFocus = false;

    if (key == CODED) {
      switch(keyCode) {
      case LEFT:
        if (CursorCharIndex > 0) { 
          CursorCharIndex--; 
        }//cursorbuffer = typed.substring(0, CursorCharIndex); }
        break;
      case RIGHT:
        if (CursorCharIndex < typed.length()) { 
          CursorCharIndex++; 
        }//cursorbuffer = typed.substring(0, CursorCharIndex); }
        break;
      case KeyEvent.VK_END:
        CursorCharIndex = typed.length(); //cursorbuffer = typed.substring(0, CursorCharIndex);
        break;
      case KeyEvent.VK_HOME:
        CursorCharIndex = 0; //cursorbuffer = typed.substring(0, CursorCharIndex);
        break;
      }
    }
    cursorbuffer = typed.substring(0, CursorCharIndex);
  }

  public void keyPressed() {
    if (OnFocus) KeyControl();
    
  }

  public void mouseClicked() {
    float dx, dy;
    int i, besti;
    float prevcharpos, nextcharpos;

    dx = abs(mouseX - x); // > 0: to the right of center ; < 0: to the left of center
    dy = abs(mouseY - y);

    if (dx <= TWidth/2 && dy <= THeight/2) {
      OnFocus = true;
      if (typed.length() > 0) {
        prevcharpos = x + 5 - textbox.textWidth(typed)/2; 
        besti = -1;  // that +5 comes from the fact that ControlsW is at (5,5) (top left) in the global window
        for (i = 1; i < typed.length()+1 && besti == -1; i++) {
          nextcharpos = x + 5 - textbox.textWidth(typed)/2 + textbox.textWidth(typed.substring(0,i));
          if (abs(mouseX - nextcharpos) > abs(mouseX - prevcharpos)) besti = i-1;
          prevcharpos = nextcharpos;
        }
        if (besti == -1) besti = typed.length();
        CursorCharIndex = besti;
        cursorbuffer = typed.substring(0,besti);
      }
    }
    else OnFocus = false;
  }

  public void display() {
    textbox.beginDraw();
    TextOverlay();
    textbox.endDraw();
    image(border, x, y);
    image(textbox, x, y);
  }

  public void TextOverlay() {
    float cpos; // cursor position (x)
    textbox.pushMatrix();
    textbox.smooth();
    buildtrickery();
    border.image(trickery, TWidth/2, THeight/2);
    textbox.image(trickery, textbox.width/2, textbox.height/2);
    textbox.fill(TColour);
    textbox.textFont(fontButton, Fontsize);
    textbox.textAlign(CENTER, CENTER);

    cpos = textbox.width/2 + textbox.textWidth(typed)/2 - (textbox.textWidth(typed) - textbox.textWidth(cursorbuffer));

    if (cpos > 0.9f*textbox.width) textbox.translate(-(cpos - textbox.width + Margin*TWidth), 0);
    if (cpos < 0.1f*textbox.width) textbox.translate(-(cpos - textbox.width + (1 - Margin)*TWidth), 0);

    textbox.text(typed, textbox.width/2, textbox.height/2);
    textbox.stroke(0);
    if(OnFocus && AUX_PulseSwitch(400)) {
      textbox.line(cpos, 0.1f*textbox.height, cpos, 0.9f*textbox.height);
    }
    if(!OnFocus) {
      CursorCharIndex = typed.length()/2; 
      cursorbuffer = typed.substring(0,CursorCharIndex);
    }
    textbox.popMatrix();
  }

  public String getText() {
    return typed;
  }

  public void setText(String _typed) {
    typed = cursorbuffer = _typed;
     CursorCharIndex = typed.length();
  }
}

class FloatNumberBox extends Textbox {
  float Data; // the floating-point number entered
  float MaxData, MinData, Epslon; // working range
  int digsleft, digsright; // formatting options; Digits to the left of decimal separator (Integer) and Digits to the right (Fractionary)

  FloatNumberBox(int _x, int _y, int _TWidth, int _THeight, float _defaultvalue, int _Border, 
  float _MaxData, float _MinData, float _Epslon, int _digsleft, int _digsright, float _Margin, int _TColour) {
    super (_x,_y,_TWidth,_THeight,"",_Border,_Margin,_TColour); // won't compile using the usual way. This is workaround
    MaxData = (_MaxData > 9.9999999999999999e37f) ? (9.9999999999999999e37f) : (_MaxData); // Avoid Infinity
    Epslon = (_Epslon < 1e-44f) ? (1e-44f) : (_Epslon); // Tolerance around zero (anything within this tolerance will be replaced by strict zero)
    MinData = (_MinData < -9.9999999999999999e37f) ? (-9.9999999999999999e37f) : (_MinData); // Avoid -Infinity
    digsleft = _digsleft;
    digsright = _digsright;
    Data = _defaultvalue; 
    typed = cursorbuffer = (abs(Data) < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
    CursorCharIndex = typed.length();
    if (Data > MaxData) {
      typed = (abs(MaxData) < 1.0e6f) ? (nfp(FloatRound(MaxData, digsright), digsleft, digsright)) : ( (MaxData > 0) ? ("+" + str(MaxData)) : (str(MaxData)) ); 
      CursorCharIndex = typed.length(); 
      Data = MaxData;
    }
    if (Data < MinData) {
      typed = (abs(MinData) < 1.0e6f) ? (nfp(FloatRound(MinData, digsright), digsleft, digsright)) : ( (MinData > 0) ? ("+" + str(MinData)) : (str(MinData)) ); 
      CursorCharIndex = typed.length(); 
      Data = MinData;
    }
    if (abs(Data) <= Epslon || str(Data).equals("NaN")) {
      typed = cursorbuffer = nfp(0, digsleft, digsright); 
      CursorCharIndex = typed.length(); 
      Data = 0;
    }
  }

  public float FloatRound(float number, float decimal) { // CAUTION: round() does not work with very big numbers (> 1e7). Probably stack overflow
    return (float)(round((number*pow(10, decimal))))/pow(10, decimal);
    
  }
  // http://processing.org/discourse/yabb2/YaBB.pl?num=1115073288
  public void keyPressed() {
    if (OnFocus) KeyFilter();
  }

  public void mouseClicked() {
    super.mouseClicked();
    if (!OnFocus) {
      typed = (abs(Data) < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
      CursorCharIndex = typed.length()/2; 
      cursorbuffer = typed.substring(0,CursorCharIndex);
    }
  }

  public void KeyFilter() { 
    /* Filter non-number characters and error checking
     basic error checking
     
     only call KeyControl() if everything is OK
     then, convert the typed string into a floating-point number
     */
    int i, j, dotpos, exppos;
    boolean errorflag = false;
    float DataIncrement;
    String TMP;

    switch(key) {
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
    case '0': 
      if (typed.length() > CursorCharIndex &&
        (typed.charAt(CursorCharIndex) == '+' || typed.charAt(CursorCharIndex) == '-' )) {
        errorflag = true;
      }
      // Avoid inserting number before "-" or "+"
    case CODED:
       switch(keyCode) {
      case UP: // fix: if textwidth changes(+ and -), update cursorbuffer    ;;    fix: exponent tweaking
        // find nearest dot or comma before current character to see whether the cursor stands over a non-integer part of the number
        dotpos = -1;  // if dotpos remains -1, is integer
        exppos = typed.length(); // if exppos remains typed.length(), there is no 'e' (CursorCharIndex cannot be bigger than this)
        for (i = 0; i < typed.length(); i++) {
          if (typed.charAt(i) == '.') dotpos = i;
          if (typed.charAt(i) == 'e' || typed.charAt(i) == 'E') exppos = i;
        }
        if (CursorCharIndex <= exppos) {
          if (dotpos == -1 && CursorCharIndex != 0) {
            DataIncrement = pow(10,typed.length() - CursorCharIndex);
          } 
          else {
            DataIncrement = (CursorCharIndex <= dotpos) ? (pow(10, -(CursorCharIndex - dotpos) )) : (pow(10, -(CursorCharIndex - dotpos - 1) ));
          }
          Data += (Data + DataIncrement < MaxData) ? (DataIncrement) : (0);
          typed = (Data < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
          if (CursorCharIndex > typed.length()) CursorCharIndex = typed.length();
          cursorbuffer = typed.substring(0, CursorCharIndex);
        } 
        else {
          TMP = typed.substring(exppos+1, typed.length()); // get current exponent
          DataIncrement = pow(10, pow(10, TMP.length() +1 -(CursorCharIndex -exppos) ));
          if (TMP.charAt(0) == '-') { // negative exponent; rising will divide number
            Data /= DataIncrement;
          }
          else {
            Data *= DataIncrement;
          }
          typed = (Data < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
          if (CursorCharIndex > typed.length()) CursorCharIndex = typed.length();
          cursorbuffer = typed.substring(0, CursorCharIndex);
        }
        break;
      case DOWN:
        // find nearest dot or comma before current character to see whether the cursor stands over a non-integer part of the number
        dotpos = -1;  // if dotpos remains -1, is integer
        exppos = typed.length(); // if exppos remains typed.length(), there is no 'e' (CursorCharIndex cannot be bigger than this)
        for (i = 0; i < typed.length(); i++) {
          if (typed.charAt(i) == '.') dotpos = i;
          if (typed.charAt(i) == 'e' || typed.charAt(i) == 'E') exppos = i;
        }
        if (CursorCharIndex <= exppos) {
          if (dotpos == -1 && CursorCharIndex != 0) {
            DataIncrement = pow(10,typed.length() - CursorCharIndex);
          } 
          else {
            DataIncrement = (CursorCharIndex <= dotpos) ? (pow(10, -(CursorCharIndex - dotpos) )) : (pow(10, -(CursorCharIndex - dotpos - 1) ));
          }
          Data -= (Data - DataIncrement > MinData) ? (DataIncrement) : (0);
          typed = (Data < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
          if (CursorCharIndex > typed.length()) CursorCharIndex = typed.length();
          cursorbuffer = typed.substring(0, CursorCharIndex);
        } 
        else {
          TMP = typed.substring(exppos+1, typed.length()); // get current exponent
          DataIncrement = pow(10, pow(10, TMP.length() +1 -(CursorCharIndex -exppos) ));
          if (TMP.charAt(0) == '-') { // negative exponent; rising will multiply number
            Data *= DataIncrement;
          }
          else {
            Data /= DataIncrement;
          }
          typed = (Data < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
          if (CursorCharIndex > typed.length()) CursorCharIndex = typed.length();
          cursorbuffer = typed.substring(0, CursorCharIndex);
        }

        break;
      default: 
        if (!errorflag) KeyControl(); 
        break;
      }
      break;
    case DELETE:
    
    case BACKSPACE:
      KeyControl();
      if (typed.length() == 0) {
        typed = "0.0"; 
        Data = 0; 
        cursorbuffer = "0"; 
        CursorCharIndex = 1;
      } // Avoid emptyness causing NaN
      if (CursorCharIndex > 1 && 
        (typed.charAt(CursorCharIndex - 1) == 'e' || typed.charAt(CursorCharIndex - 1) == 'E') && 
        typed.length() == CursorCharIndex) {
        typed += '0';
      } // Avoid 'e' and 'E' as last char
      if (CursorCharIndex > 1 && 
        CursorCharIndex == typed.length() && 
        (typed.charAt(CursorCharIndex - 1) == '+' || typed.charAt(CursorCharIndex - 1) == '-')) {
        typed += '0';
      } 
      // avoid '-' and '+' as last char
      if (typed.length() > CursorCharIndex &&
        (typed.charAt(0) == '+' || typed.charAt(0) == '-') &&
        (typed.charAt(CursorCharIndex) == '+' || typed.charAt(CursorCharIndex) == '-')) 
      {
        typed = typed.substring(0,CursorCharIndex) + typed.substring(CursorCharIndex+1,typed.length());
      }
      // Avoid "++" , "+-", "-+", and "--"; Avoid "+e", "-e", "+E", and "-E". Apagando e tinha notacao cientifica E sinal no numero
      // apagando um 'e', apaga tb o sinal q vem depois
      if (typed.length() > CursorCharIndex &&
        ((typed.charAt(0) == 'e' || typed.charAt(0) == 'E') || 
        ((typed.charAt(0) == '+' || typed.charAt(0) == '-') && 
        (typed.charAt(1) == 'e' || typed.charAt(1) == 'E' ) ) )) {
        typed = typed.substring(0,CursorCharIndex) + '1' + typed.substring(CursorCharIndex,typed.length()); 
        CursorCharIndex++; 
        cursorbuffer = typed.substring(0, CursorCharIndex);
      }
      // Avoid "e" or "E" as first char or as second char if first is "-" or "+"
      break;
    case '.':
      for(i = 0; i < typed.length(); i++) {
        if (typed.charAt(i) == '.') errorflag = true;
      }
      if (!errorflag) {
        KeyControl(); 
        Data = PApplet.parseFloat(typed);
      }
      break;
    case '+': // notacao cientifica: 1.34565e+10 e sinal: +1.23456e+10. Soh pode colocar fora da posicao de sinal se tiver o 'e'
      if (((typed.charAt(0) == '-' || typed.charAt(0) == '+') && 
        (CursorCharIndex == 1 || CursorCharIndex == 0)) ||
        ( CursorCharIndex > 0 &&
        ((typed.charAt(CursorCharIndex-1) != 'e' && typed.charAt(CursorCharIndex-1) != 'E')) ) ) {
        errorflag = true;
      }
      for (i = 1; i < typed.length(); i++) {
        if ((typed.charAt(i) == '+' || typed.charAt(i) == '-') &&
          CursorCharIndex != 0) {
          errorflag = true;
        }
      }
      if (!errorflag) {
        KeyControl();
      }
      break;
    case '-': // notacao cientifica: 1.2345e-10 e sinal: -12345e+10. Soh pode colocar fora da posicao de sinal se tiver o 'e'
      if (((typed.charAt(0) == '-' || typed.charAt(0) == '+') && 
        (CursorCharIndex == 1 || CursorCharIndex == 0)) ||
        ( CursorCharIndex > 0 &&
        ((typed.charAt(CursorCharIndex-1) != 'e' && typed.charAt(CursorCharIndex-1) != 'E')) ) ) {
        errorflag = true;
      } 
      // n pode colocar ++ ou +- ou -- ou -+ como sinal E nem colocar no meio se n tiver o 'e'
      for (i = 1; i < typed.length(); i++) {
        if ((typed.charAt(i) == '-' || typed.charAt(i) == '+') &&
          CursorCharIndex != 0) {
          errorflag = true;
        }
      }
      if (!errorflag) {
        KeyControl();
      }
      break;
    case 'e':
    case 'E':
      for (i = 1; i < typed.length(); i++) {
        if (typed.charAt(i) == 'e' || typed.charAt(i) == 'E') errorflag = true;
        if (CursorCharIndex < typed.length()) {
          for (j = CursorCharIndex; j < typed.length(); j++) {
            if (typed.charAt(j) == '.' || typed.charAt(j) == ',') errorflag = true;
          }
        }
      }
      if (!errorflag) {
        KeyControl();
        if (CursorCharIndex == typed.length()) typed += '0'; // avoid NaN errors
        if (CursorCharIndex == 1 || 
          (typed.charAt(CursorCharIndex - 2) == '+'
          || typed.charAt(CursorCharIndex - 2) == '-' )) {
          typed = typed.substring(0,CursorCharIndex-1) + '1' + typed.substring(CursorCharIndex-1,typed.length()); 
          CursorCharIndex++; 
          cursorbuffer = typed.substring(0, CursorCharIndex);
        }
      }
      break;
    case RETURN:
    case ENTER: 
      OnFocus = false; 
      
      break;
    }
    Data = PApplet.parseFloat(typed);
    if (Data > MaxData) {
      typed = cursorbuffer = (abs(MaxData) < 1.0e6f) ? (nfp(FloatRound(MaxData, digsright), digsleft, digsright)) : ( (MaxData > 0) ? ("+" + str(MaxData)) : (str(MaxData)) ); 
      CursorCharIndex = typed.length(); 
      Data = MaxData;
    }
    if (Data < MinData) {
      typed = cursorbuffer = (abs(MinData) < 1.0e6f) ? (nfp(FloatRound(MinData, digsright), digsleft, digsright)) : ( (MinData > 0) ? ("+" + str(MinData)) : (str(MinData)) ); 
      CursorCharIndex = typed.length(); 
      Data = MinData;
    }
    if (!OnFocus) {
      if (abs(Data) <= Epslon || str(Data).equals("NaN")) {
        typed = cursorbuffer = str(0); 
        CursorCharIndex = typed.length(); 
        Data = 0;
      }
      // round whatever is smaller than Epslon and if, with all the exhaustive error checking, the user is STILL able to NaN things up, fix
      
        else {
        typed = (abs(Data) < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
        CursorCharIndex = typed.length()/2; 
        cursorbuffer = typed.substring(0,CursorCharIndex);
      }
    }
  }

  public float getData() {
    return Data;
  }

  public void setData(float _Data) {
    Data = _Data;
    typed = (abs(Data) < 1.0e6f) ? (nfp(FloatRound(Data, digsright), digsleft, digsright)) : ( (Data > 0) ? ("+" + str(Data)) : (str(Data)) ); 
    CursorCharIndex = typed.length()/2; 
    cursorbuffer = typed.substring(0,CursorCharIndex);
  }
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "Diagramas2" });
  }
}
