//Cores das fases
color ALFA = color(0,152,113);
color BETA = color(255,140,136);
color GAMA = color(235,238,150);
color DELTA = color(160,200,220);
color FE3C = color(174,185,172);

//desenha a textura da estrutura lamelar, usando linhas e random
PImage lamelar(float fracao, float angulo, String fase, boolean led){
  randomSeed(6);
  color c1 = 0, c2 = 0;
  
  if(fase == "ALFA+BETA"){ 
    c1 = color(ALFA);
    c2 = color(BETA);
  }
  if(fase == "PERLITA"){ 
    c1 = color(ALFA);
    c2 = color(FE3C);
  }
  if(fase == "FERRITA (ALFA)+AUSTENITA"){ 
    c2 = color(GAMA);
    c1 = color(ALFA);
  }
  if(fase == "AUSTENITA+CEMENTITA"){ 
    c2 = color(GAMA);
    c1 = color(FE3C);
  }

  lamelar.pushMatrix();
  lamelar.beginDraw();
  lamelar.strokeWeight(2);   

  lamelar.rotate(angulo);

  if(!led){
    for(int i=0; i< lamelar.width; i+=2){
      if(random(0,1)<fracao){
        lamelar.stroke(c2);
      }
      else{
        lamelar.stroke(c1);
      }

      lamelar.line(0, i, lamelar.width/2, i) ;
      lamelar.line(0, lamelar.width/3, lamelar.width*2/3+3, i) ;
      lamelar.line(0, lamelar.width*2/3+4, lamelar.width, i) ;
    }
  }
  else{ //fazendo a estrutura da ledeburita
    lamelar.strokeWeight(2.6);
    for(int i=0; i< lamelar.width; i+=4){
      for(int j=0; j< lamelar.height; j+=4){
         if(random(0,1)<fracao){
          if(fase=="AUSTENITA+CEMENTITA")lamelar.stroke(c2);
          else lamelar.stroke(c1);
        }  
        else{
         if(fase=="AUSTENITA+CEMENTITA") lamelar.stroke(c1);
         else lamelar.stroke(c2);
        }
        lamelar.line(i,j,i+6,j+6);
      }
    }
  }
  lamelar.stroke(0);
  lamelar.endDraw();
  lamelar.popMatrix();
  return lamelar.get();
}

//cria e rotaciona texturas
void Textura(float fracao, String fase, boolean led){
  lamelar1 = lamelar(fracao, 0, fase, led);
  lamelar2 = lamelar(fracao, PI/10, fase, led);
  lamelar3 = lamelar(fracao, -PI/8, fase, led);
}

//desenha os grãos com texturas aplicadas
/////////http://processing.org/discourse/yabb2/YaBB.pl?num=1229687224 - textura
void DrawTextured(float tamanho, String fase, boolean led, boolean tipograo){ //false normal, true graos precipitando
  pg.fill(0);
  lamelar(W2, 0, fase, led);
  pgShape.background(255);
  pgMask1.background(0);
  DrawGrao(pg, 0, tamanho+0.001);
  DrawGrao(pgMask1, 0, tamanho);
  piMask = pgMask1.get(0, 0, width, height);
  pgShape.background(0);
  pgShape.image(lamelar1, 0, 0);
  pgShape.mask(piMask);

  pgMask2.background(0);
  DrawGrao(pg, 1, tamanho+0.001);
  DrawGrao(pgMask2, 1,tamanho);
  piMask = pgMask2.get(0, 0, width, height);
  pgShape.image(lamelar2, 0, 0);
  pgShape.mask(piMask);

  pg.image(pgShape, 0, 0);

  pgMask3.background(0);
  DrawGrao(pg, 2, tamanho+0.001); 
  DrawGrao(pgMask3, 2,tamanho);
  piMask = pgMask3.get(0, 0, width, height);
  pgShape.image(lamelar3, 0, 0);
  pgShape.mask(piMask);

  pg.image(pgShape, 0, 0);

  DrawGrao(pg, 3, tamanho+0.001); 
  DrawGrao(pgMask1, 3, tamanho);
  piMask = pgMask1.get(0, 0, width, height);
  pgShape.image(lamelar2, 0, 0);
  pgShape.mask(piMask);

  pg.image(pgShape, 0, 0);
}









