// desenha grãos após o crescimento, controlando o tamanho deles (para o diagrama do Fe); tamanho
// é a área relativa ocupada pelos grãos(assim, teremos um scale de raizde_tamanho
void DrawGrao(PGraphics pg, int tipo, float tamanho){
  pg.beginDraw();
  if(tipo == 0){
    pg.pushMatrix();
    pg.scale(sqrt(tamanho));
    pg.beginShape();
    pg.vertex(1.0, 44.0);
    pg.bezierVertex(1.0, 44.0, 27.0, 51.0, 30.0, 42.0);
    pg.bezierVertex(33.0, 33.0, 49.0, 34.0, 46.0, 23.0);
    pg.bezierVertex(43.0, 12.0, 47.0, 1.0, 47.0, 1.0);
    pg.bezierVertex(47.0, 1.0, 0.0, 0.0, 0.0, 0.0);
    pg.bezierVertex(0.0, 0.0, 0.0, 43.0, 0.0, 43.0);
    pg.endShape();
    pg.popMatrix();
  }

  if(tipo == 1){
    pg.pushMatrix();
    pg.translate(100 - 100*tamanho, 0); //ok
    pg.scale(sqrt(tamanho));
    pg.beginShape();
    pg.vertex(40.0, 32.0);
    pg.bezierVertex(40.0, 32.0, 50.0, 44.0, 59.0, 48.0);
    pg.bezierVertex(68.0, 52.0, 57.0, 44.0, 69.0, 52.0);
    pg.bezierVertex(81.0, 60.0, 82.0, 61.0, 84.0, 60.0);
    pg.bezierVertex(86.0, 59.0, 100.0, 59.0, 100.0, 59.0);
    pg.bezierVertex(100.0, 59.0, 100.0, -1.0, 100.0, 0.0);
    pg.bezierVertex(100.0, 1.0, 46.0, -1.0, 46.0, 0.0);
    pg.bezierVertex(46.0, 1.0, 43.0, 25.0, 47.0, 26.0);
    pg.bezierVertex(51.0, 27.0, 40.0, 31.0, 40.0, 32.0);
    pg.endShape();
    pg.popMatrix();
  }
  if(tipo == 2){
    pg.pushMatrix();
    pg.translate(100 - 100*tamanho, 100 - 100*tamanho);
    pg.scale(sqrt(tamanho));

    pg.beginShape();
    pg.vertex(57.0, 47.0);
    pg.bezierVertex(57.0, 47.0, 45.0, 65.0, 45.0, 69.0);
    pg.bezierVertex(45.0, 73.0, 41.0, 83.0, 42.0, 91.0);
    pg.bezierVertex(43.0, 99.0, 43.0, 100.0, 43.0, 100.0);
    pg.bezierVertex(43.0, 100.0, 100.0, 99.0, 100.0, 100.0);
    pg.bezierVertex(100.0, 101.0, 101.0, 58.0, 101.0, 58.0);
    pg.bezierVertex(101.0, 58.0, 85.0, 58.0, 84.0, 61.0);
    pg.bezierVertex(83.0, 64.0, 63.0, 46.0, 63.0, 49.0);
    pg.bezierVertex(63.0, 52.0, 57.0, 47.0, 57.0, 47.0);
    pg.endShape();
    pg.popMatrix();
  }
  if (tipo == 3){ 
    pg.pushMatrix();
    pg.translate(0, 100 - 100*tamanho);
    pg.scale(sqrt(tamanho));
    pg.beginShape();
    pg.vertex(41.0, 33.0);
    pg.bezierVertex(41.0, 33.0, 57.0, 50.0, 57.0, 47.0);
    pg.bezierVertex(57.0, 44.0, 43.0, 69.0, 45.0, 69.0);
    pg.bezierVertex(47.0, 69.0, 39.0, 86.0, 43.0, 92.0);
    pg.bezierVertex(47.0, 98.0, 44.0, 100.0, 44.0, 100.0);
    pg.bezierVertex(44.0, 100.0, 0.0, 100.0, 0.0, 100.0);
    pg.bezierVertex(0.0, 100.0, 1.0, 43.0, 1.0, 43.0);
    pg.bezierVertex(1.0, 43.0, 17.0, 50.0, 25.0, 46.0);
    pg.bezierVertex(33.0, 42.0, 25.0, 46.0, 25.0, 46.0);
    pg.bezierVertex(25.0, 46.0, 40.0, 32.0, 41.0, 30.0);
    pg.endShape();
    pg.popMatrix();
  }
  pg.endDraw();
}


void cresceGrao(float W2, PGraphics pg, boolean led){
  pg.pushMatrix(  ); 
  pg.scale(1.6);
  pg.translate(-2,-5);
  pg.stroke(0);
  Agrao = PI*1.5*1.5*(raio[0]*raio[0]*2 + raio[1]*raio[1]*2 +raio[2]*raio[2]+raio[3]*raio[3]*2);
  raioupdate(Agrao, W2);
  
  grao(15.0, 15.0,raio[0], 1, pg);
  grao(47.0,15.0,raio[1],2, pg);
  grao(37.0,35.0,raio[3],0, pg);
  grao(10.0, 40.0,raio[2],0, pg);
  grao(64.0,30.0,raio[1],0, pg);
  grao(25.0,61.0,raio[3],1, pg);
  grao(53.0,58.0,raio[0],0, pg);
  pg.popMatrix();
}

//atualiza o raio até que a área dos grãos ocupe a imagem na proporção certa
void raioupdate(float agrao, float razao){
  if(razao<=0){
    raio[0] = 0;
    raio[1] = 0;
    raio[2] = 0;
    raio[3] = 0;
  }
  else{
    while((agrao/(13000)<razao)){
      raio[0] += 0.2;
      raio[1] += 0.225;
      raio[2] += 0.25;
      raio[3] += 0.2;
      agrao = PI*1.5*1.5*(raio[0]*raio[0]*2 + raio[1]*raio[1]*2 +raio[2]*raio[2]+raio[3]*raio[3]*2);
    }
    while((agrao/(13000)>razao)){
      raio[0] -= 0.2;
      raio[1] -= 0.225;
      raio[2] -= 0.25;
      raio[3] -= 0.2;
      agrao = PI*1.5*1.5*(raio[0]*raio[0]*2 + raio[1]*raio[1]*2 +raio[2]*raio[2]+raio[3]*raio[3]*2);
    }
  }
}


void grao(float xpos, float ypos, float raio, int tipo, PGraphics pg){
  pg.pushMatrix();
  pg.translate(xpos, ypos);
  pg.scale(raio/50);
  
  if(tipo == 0){
    pg.beginShape();
    pg.vertex(18.0, -52.0);
    pg.bezierVertex(30.0, -50.0, 40.0, -43.0, 46.0, -31.0);
    pg.bezierVertex(52.0, -19.0, 52.0, -22.0, 51.0, -12.0);
    pg.bezierVertex(50.0, -2.0, 50.0, 0.0, 50.0, 1.0);
    pg.bezierVertex(50.0, 2.0, 49.0, 13.0, 44.0, 20.0);
    pg.bezierVertex(39.0, 27.0, 37.0, 30.0, 34.0, 35.0);
    pg.bezierVertex(31.0, 40.0, 20.0, 47.0, 22.0, 45.0);
    pg.bezierVertex(24.0, 43.0, 12.0, 51.0, 6.0, 51.0);
    pg. bezierVertex(0.0, 51.0, -1.0, 47.0, -1.0, 47.0);
    pg.bezierVertex(-1.0, 47.0, -10.0, 43.0, -13.0, 43.0);
    pg. bezierVertex(-16.0, 43.0, -24.0, 36.0, -25.0, 34.0);
    pg. bezierVertex(-26.0, 32.0, -42.0, 21.0, -41.0, 22.0);
    pg.bezierVertex(-40.0, 23.0, -46.0, 10.0, -45.0, 11.0);
    pg. bezierVertex(-44.0, 12.0, -44.0, 3.0, -44.0, 3.0);
    pg.bezierVertex(-44.0, 3.0, -46.0, -21.0, -46.0, -21.0);
    pg. bezierVertex(-46.0, -21.0, -40.0, -36.0, -38.0, -38.0);
    pg. bezierVertex(-36.0, -40.0, -32.0, -49.0, -27.0, -49.0);
    pg.bezierVertex(-22.0, -49.0, -20.0, -54.0, -13.0, -54.0);
    pg.bezierVertex(-6.0, -54.0, -11.0, -55.0, -11.0, -55.0);
    pg.bezierVertex(-11.0, -55.0, 1.0, -53.0, 1.0, -53.0);
    pg.bezierVertex(1.0, -53.0, 18.0, -52.0, 17.0, -52.0);
    pg.endShape();
  }
  if(tipo==1){
    pg.beginShape();
    pg.vertex(18.0, -52.0);
    pg. bezierVertex(30.0, -50.0, 39.0, -41.0, 45.0, -29.0);
    pg. bezierVertex(51.0, -17.0, 49.0, -21.0, 51.0, -11.0);
    pg.bezierVertex(53.0, -1.0, 54.0, -2.0, 54.0, -1.0);
    pg.bezierVertex(54.0, 0.0, 49.0, 13.0, 44.0, 20.0);
    pg.bezierVertex(39.0, 27.0, 35.0, 27.0, 32.0, 32.0);
    pg.bezierVertex(29.0, 37.0, 21.0, 41.0, 22.0, 45.0);
    pg. bezierVertex(23.0, 49.0, 12.0, 51.0, 6.0, 51.0);
    pg. bezierVertex(0.0, 51.0, -1.0, 47.0, -1.0, 47.0);
    pg. bezierVertex(-1.0, 47.0, -10.0, 43.0, -13.0, 43.0);
    pg. bezierVertex(-16.0, 43.0, -16.0, 41.0, -23.0, 38.0);
    pg. bezierVertex(-30.0, 35.0, -28.0, 39.0, -39.0, 30.0);
    pg. bezierVertex(-50.0, 21.0, -41.0, 30.0, -47.0, 23.0);
    pg.bezierVertex(-53.0, 16.0, -48.0, 19.0, -51.0, 0.0);
    pg.bezierVertex(-54.0, -19.0, -46.0, -21.0, -46.0, -21.0);
    pg.  bezierVertex(-46.0, -21.0, -37.0, -34.0, -35.0, -36.0);
    pg. bezierVertex(-33.0, -38.0, -32.0, -49.0, -27.0, -49.0);
    pg.  bezierVertex(-22.0, -49.0, -20.0, -54.0, -13.0, -54.0);
    pg.  bezierVertex(-6.0, -54.0, -11.0, -55.0, -11.0, -55.0);
    pg.  bezierVertex(-11.0, -55.0, 1.0, -53.0, 1.0, -53.0);
    pg. bezierVertex(1.0, -53.0, 18.0, -52.0, 17.0, -52.0);
    pg. endShape();
  }
  if(tipo==2){
    pg.beginShape();
    pg.vertex(18.0, -52.0);
    pg. bezierVertex(30.0, -50.0, 39.0, -41.0, 45.0, -29.0);
    pg. bezierVertex(51.0, -17.0, 49.0, -21.0, 51.0, -11.0);
    pg.bezierVertex(53.0, -1.0, 54.0, -2.0, 54.0, -1.0);
    pg.bezierVertex(54.0, 0.0, 49.0, 13.0, 44.0, 20.0);
    pg.bezierVertex(39.0, 27.0, 35.0, 27.0, 32.0, 32.0);
    pg. bezierVertex(29.0, 37.0, 21.0, 41.0, 22.0, 45.0);
    pg. bezierVertex(23.0, 49.0, 12.0, 51.0, 6.0, 51.0);
    pg.bezierVertex(-1.0, 47.0, -2.0, 48.0, -2.0, 41.0);
    pg.bezierVertex(-2.0, 34.0, -5.0, 36.0, -12.0, 33.0);
    pg.bezierVertex(-19.0, 30.0, -11.0, 32.0, -22.0, 23.0);
    pg.bezierVertex(-33.0, 14.0, -30.0, 20.0, -36.0, 13.0);
    pg.bezierVertex(-42.0, 6.0, -48.0, 19.0, -51.0, 0.0);
    pg. bezierVertex(-54.0, -19.0, -46.0, -21.0, -46.0, -21.0);
    pg.bezierVertex(-46.0, -21.0, -37.0, -34.0, -35.0, -36.0);
    pg. bezierVertex(-33.0, -38.0, -32.0, -49.0, -27.0, -49.0);
    pg. bezierVertex(-22.0, -49.0, -22.0, -53.0, -13.0, -54.0);
    pg.bezierVertex(-4.0, -55.0, -21.0, -51.0, -11.0, -55.0);
    pg. bezierVertex(-1.0, -59.0, -9.0, -61.0, 0.0, -62.0);
    pg.bezierVertex(9.0, -63.0, 18.0, -52.0, 17.0, -52.0);
    pg.endShape();
  }
  pg.popMatrix();
}


